#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 16 "lexgrog.c"

#define  YY_INT_ALIGNED long int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 146
#define YY_END_OF_BUFFER 147
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int32_t yy_accept[1680] =
    {   0,
        0,    0,    0,    0,   72,   72,   72,   72,    0,    0,
        0,    0,    0,    0,    0,    0,  124,  124,    0,    0,
        0,    0,    0,    0,  131,  131,    9,    9,    0,    0,
        0,    0,    0,    0,    0,    0,  147,  146,   30,   30,
       30,  145,   72,   72,  145,  145,  145,  143,  145,  145,
      141,   88,   72,   72,  145,   88,  111,  111,  111,  106,
      111,  113,  113,  112,  118,  118,  118,  117,  123,  123,
      123,  123,  123,  124,  126,  126,  125,  128,  128,  127,
      130,  130,  129,  131,  131,  145,  142,  145,  145,  145,
        8,   11,    8,    8,    7,    7,    7,    5,    7,   19,

       19,   19,   20,   20,    0,   29,    0,   28,   28,   30,
       72,    0,  143,    0,    0,  144,   72,   72,  144,  140,
      144,  144,  140,   88,   72,    0,    0,   51,    0,    0,
      143,    0,  141,   75,   72,   81,    0,   51,   67,    0,
        0,   69,   71,    0,    0,   66,   68,   66,    0,    0,
        0,    0,    0,    0,   72,    0,   72,   72,  144,  140,
       88,   72,    0,   69,    0,  111,    0,    0,  106,   99,
      100,  101,  102,  103,  104,  105,  113,  112,  118,    0,
        0,    0,  117,  117,  123,    0,    0,    0,  124,  126,
      125,  128,  127,  130,  129,  131,  142,    0,    0,  131,

      131,  144,  144,  144,  144,  131,  142,   56,    0,  131,
       41,    8,    0,   10,    0,   11,    8,    7,    6,    0,
        4,    5,    4,    5,    4,    6,   19,    0,    0,    0,
       19,   20,   29,    0,    0,    0,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   60,    0,   62,    0,
        0,   62,    0,   72,    0,    0,    0,   38,   38,   38,
       38,   38,   38,   38,   38,   62,    0,   52,   55,    0,
        0,    0,    0,    0,  135,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,   50,    0,   62,    0,
       62,   51,   51,   51,    0,   63,   81,   77,    0,    0,

        0,    0,    0,    0,    0,    0,   80,   80,   80,    0,
        0,    0,    0,    0,    0,   74,    0,   82,   83,    0,
       84,    0,    0,   86,    0,    0,   72,    0,    0,   38,
       38,   38,   38,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   98,  107,
      108,  109,  110,  106,   99,  100,  101,  102,  103,  104,
      105,    0,    0,    0,    0,    0,    0,   65,    0,  131,
       40,   40,  131,   40,   40,   40,   40,   39,   56,    8,
        0,    0,    0,   10,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    8,    6,    6,

        4,    4,    5,    5,    5,    4,    0,    0,    0,    0,
        0,   17,    0,   22,   28,   28,   28,   28,   21,   28,
       28,   28,   61,    0,    0,    0,    0,   62,    0,    0,
        0,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   55,   53,   43,    0,    0,    0,    0,
        0,  133,   64,    0,  135,   49,  134,    0,    0,   31,

        0,   36,    0,  132,   35,   55,    0,   37,   34,   54,
       33,    0,    0,    0,   89,   78,   67,   57,   68,   73,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   90,    0,   92,   97,   93,   94,   95,   96,
       33,    0,    0,    0,   69,    0,   98,  107,  108,  109,
      110,    0,    0,    0,  121,  119,    0,   40,   40,   40,
       40,   39,   40,   40,    8,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    8,    4,

        4,    5,    5,    5,    0,    4,    4,   13,   15,   14,
       16,   12,   18,   22,   26,   27,   21,   23,   25,   24,
       61,   57,    0,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   31,   38,   36,
       38,   38,   35,   38,   38,   37,   34,   38,   33,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   42,  137,
      136,   47,  133,   64,   48,   49,  134,  139,  138,   31,

       44,   36,   32,  132,   54,   35,   35,   45,   37,   34,
       33,    0,    0,    0,   89,   57,   79,    0,   76,   58,
       85,   87,   38,   38,   38,   38,   38,   38,   38,   38,
       33,   38,   38,   38,   38,   38,   38,   90,   91,   92,
       97,   93,   94,   95,   96,    0,   70,    0,  115,    0,
      121,  122,  119,  120,   40,   40,    8,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    8,    4,    4,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    4,    4,   26,   27,   23,   25,   24,   58,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   31,   38,
       36,   32,   38,   38,   35,   35,   38,   37,   34,   33,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       38,   38,   38,  137,  136,   47,  139,  138,   46,   36,
       45,    0,   58,   58,   87,   38,   38,   38,   38,   38,

       38,   38,   38,   38,   38,   91,   70,  114,  115,  116,
      122,  120,    8,    3,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    8,    4,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    2,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    2,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        4,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       36,   38,   38,   38,   38,   38,   38,   38,    0,   38,
       38,  114,  116,    8,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    8,    4,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    2,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    2,    0,    2,    2,    5,    5,
        2,    5,    5,    5,    5,    5,    5,    5,    5,    2,
        5,    2,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    2,    2,    2,    0,    0,
        2,    0,    0,    0,    0,    0,    0,    0,    0,    2,
        0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    4,   38,   38,   38,   59,
        8,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    8,    4,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        2,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    2,    2,    2,
        5,    5,    2,    5,    5,    5,    5,    5,    5,    5,

        5,    2,    5,    2,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    0,    0,
        0,    2,    5,    5,    5,    5,    5,    5,    5,    5,
        2,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    2,    0,    0,    0,    0,    0,    0,    0,    0,
        2,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    4,   59,    8,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    8,    4,    4,
        5,    5,    2,    0,    0,    2,    0,    2,    0,    2,
        0,    0,    0,    0,    0,    0,    2,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    4,    4,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    9,
        1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        2,    2,    0,    0,    0,    0,    0,    0,    2,    2,
        2,    0,    2,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    2,
        0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    2,    2,    0,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    2,
        2,    2,    2,    2,    2,    0,    0,    0,    0,    0,
        0,    0,    0,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    0,    0,    0,    0,    0,
        0,    2,    2,    2,    0,    0,    0,    0,    0,    0,
        0,    0,    2,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    2,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    2,    3,    4,
        1,    1,    5,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    6,    7,    8,    9,   10,    7,   11,   12,   13,
       14,   15,   16,   17,   18,   19,    1,   20,   21,   22,
       23,   24,   25,   26,   27,   28,   28,    1,    1,    1,
        1,    1,    1,    1,   29,   30,   31,   32,   33,   34,
       35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
       45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
       55,   56,   57,    7,   58,   59,   60,   61,   62,   63,

       64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
       74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
       84,   85,    7,   86,    7,   87,    1,    1,   88,    1,
        1,   89,   90,   91,    1,    1,   92,   93,    1,    1,
       94,    1,   95,   96,   97,   98,    1,    1,   99,    1,
      100,  101,    1,    1,    1,  102,  103,  104,    1,    1,
      105,    1,    1,  106,  107,  108,  109,  110,  111,  112,
        1,    1,  113,  114,  115,  116,  117,  118,  119,  120,
      121,    1,  122,  123,  124,    1,  125,  126,  127,  128,
        1,    1,    1,    1,  129,  130,    1,    1,    1,    1,

        1,    1,    1,  131,    1,    1,    1,  132,  133,    1,
        1,    1,    1,    1,    1,  134,  135,    1,    1,    1,
        1,    1,    1,  136,    1,    1,    1,  137,  138,    1,
      139,    1,    1,    1,  140,  141,    1,    1,  142,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[143] =
    {   0,
        1,    1,    2,    3,    4,    2,    1,    5,    1,    1,
        1,    6,    7,    1,    1,    1,    1,    1,    1,    8,
        9,    9,    9,    9,    8,    8,    8,    8,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,    1,    1,    1,    1,    1,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1
    } ;

static const flex_int32_t yy_base[1864] =
    {   0,
        0,    0,    0,    2,    7,    0,  147,  151,  154,  155,
      236,    0,  378,    0,  153,  516, 6891, 6879,  595,    0,
      737,    0,  879,    0,  158,  167,  162,  175,  177,  178,
        0,    0,  182,  187, 6863, 6855, 6846, 8159, 8159,  207,
     6831, 8159,  519,  526, 1019,  509, 6768,  192, 6795, 6746,
        0, 1072, 1030, 1037, 6787,  515, 8159, 6754, 6725,  203,
      525, 8159, 6732,    0, 8159, 6721,  157,  225, 8159, 6710,
     6635, 6618, 6621,    0, 8159, 6676,    0, 8159, 6667,    0,
     8159, 6666,    0, 1042, 1048, 6665,  537,  217, 6654, 6601,
        0,  554, 6654, 6642, 8159, 6634,  516, 1060, 6626,    0,

      549, 6623, 8159, 6622,  573,  562, 6621,    0, 1126, 1096,
     1161, 1177,  577, 1053, 1105, 8159, 1182, 1193, 1204,  517,
     6565, 1008, 1258, 1333, 1222, 1010, 6602, 6596, 6596, 6507,
      582,  583,    0, 8159, 1032,    0, 1229,    0, 8159, 1199,
     1014,  588, 8159, 1091,  967, 6503, 8159, 8159, 6558,    0,
     6543, 6526, 1338, 1107, 1212, 1196, 1240, 1365, 6519, 1393,
     1176, 1425, 1379, 8159, 1050, 8159, 6431, 1263, 1306, 1026,
     1064, 1118, 1123, 1138, 1187, 1217, 8159,    0, 8159, 6430,
     6427, 6426, 1218, 1233, 8159, 6410, 6407, 6412,    0, 8159,
        0, 8159,    0, 8159,    0, 1264, 1286, 1329, 6472, 1384,

     1444, 6465, 1399, 6462, 6409, 1461, 1312, 1376, 6453, 1266,
     8159,    0, 1469, 1474, 6443, 1481, 6440, 8159, 6418, 6427,
     6426, 6416, 6261, 1446, 6260,    0,    0, 1457, 6263, 1463,
     1501, 8159, 8159, 6262, 1521, 6261,    0, 1380, 1491, 6192,
      178, 1498, 6190, 1311, 6183, 1499, 1057, 6257, 1544, 6242,
     1489, 1554, 1503, 1575, 1581, 1585, 1589, 6255, 1614, 1618,
     1157, 1040, 1293, 1674, 1749, 1452, 1486, 8159, 6254, 1605,
     6213, 1610, 6212,  983, 1594, 1613, 1622, 6182, 1396,    0,
     6177, 6189,  995, 1105, 6187, 1612,    0, 6238, 1627, 1600,
     1685,    0, 6232,    0, 6235, 1526,    0, 8159,    0, 6188,

     1000, 6187, 6162, 6177, 6164, 6172, 8159,    0,    0, 1622,
        0,    0, 1175, 6149, 6164, 8159,    0, 8159, 8159,    0,
     8159,    0, 1750, 8159, 1689,    0, 1728, 1269, 6227, 1709,
     6226, 1834, 1909, 6150, 1815, 6152, 6144, 1131, 6143, 6142,
     1856, 1630, 1252, 6140, 6155, 1361, 6137, 6085, 1535, 1565,
     1595, 1678, 1679, 1702, 1722, 1737, 1742, 1743, 1760, 1776,
     1777, 6077, 6072, 6069, 6085, 6074, 6073, 1782, 1787, 1838,
        0, 1840, 1792, 6142, 1602, 6139, 6086, 8159, 1796,    0,
     1994, 6139, 1999, 2015, 6137,  529, 6134, 1048, 2025, 5997,
     6078, 6008, 5995,   99, 1372, 6010, 6018, 6114,    0, 6101,

     6110, 6109, 6108, 6106, 1933, 6075, 6037, 6060, 6033, 6054,
     6027, 8159, 6026,    0, 1800, 1839, 1848, 1854, 1856, 1866,
     1882, 1898, 1902, 1927, 1442, 5988, 6003, 1929, 1482, 5986,
     6001, 6062, 1957, 2004, 1643,  170, 2046, 1938, 6047, 1295,
     1144, 1942,  551, 1949, 6060, 2066, 1397, 2070, 1466, 1635,
     2027, 2057, 2097, 1228, 1950, 2178, 1497, 1173, 1821, 1974,
     1136, 2105, 6059, 2092,    0, 2169,    0, 6058, 2099, 6048,
     2181, 6056, 2074, 2051, 1026, 6055, 6054, 2234, 2285, 2358,
     1401, 2440, 2107,    0, 8159, 2040, 1944, 2009, 2076, 2085,
     2102, 2114, 2154, 2164, 2171, 2195, 2197, 2199, 2230, 2236,

     2237, 2238, 2242, 2243, 2448,    0, 2247, 2248, 2256,    0,
     2287, 1490, 5973, 5988, 2291, 8159, 8159, 2292, 8159, 8159,
        0,    0, 6043, 5997, 5996,    0,    0, 6044, 6039, 6046,
     2451, 1276, 2442, 1309, 1370, 2230, 1588, 1590, 2448, 2410,
     6045, 2308, 2293, 5965, 2297, 2298, 2302, 2303, 2304, 2337,
     2338, 1678, 5963, 5978, 8159, 5988, 2370, 2371, 2375, 2376,
     2380, 5977, 5983, 5978, 2469, 2410, 5977,    0, 2475, 2493,
     6034,    0, 2444,    0,    0, 2499, 6026, 2504, 2545, 5998,
     2450, 5984, 1217, 1546, 1486, 6012, 1792, 1865, 2448,  478,
     1589, 1772, 5892, 5891, 5928, 5894, 5930, 5898, 5981, 5978,

     5977, 5976, 5971, 2643, 2782, 5970, 5968, 8159, 8159, 8159,
     8159, 8159, 8159,    0,    0,    0, 2411,    0,    0,    0,
     2483, 2515, 5918, 2551, 2455, 2509,    0, 5956,    0, 1353,
     2557, 2562,    0, 2574, 2580, 2584, 2588, 2592, 2596, 2600,
     2605, 2609, 2613, 2617, 2621, 2649, 2653, 2657, 2661, 2665,
     2671, 2686, 2673,    0, 2692, 2697, 2701,    0, 2709,    0,
     5969,    0, 5910, 1853, 5909, 5884, 5899, 5886, 5894, 5960,
        0, 2713, 2717, 1387, 1962, 1158, 1649, 5959, 2920, 5958,
     5957, 2971, 5956, 1565, 2722, 5955, 2721, 1519, 8159,    0,
        0,    0, 2568, 2635, 2680, 2703, 2725,    0,    0, 2729,

     2731, 2733, 2748, 2749,    0, 2750, 2754,    0, 2755, 2756,
     2760, 2764, 5954, 5900, 2786, 2788, 8159, 5899, 8159, 2790,
     8159,    0, 2794, 1732, 2798, 2802, 2810, 2825, 2829, 2833,
     2837, 1993, 5871, 5886, 2089, 1625, 1875, 2804, 2812, 2819,
     2839, 2841, 2843, 2845, 2849, 5896, 8159, 5892, 2850, 5880,
     2851, 2855, 2856, 2857, 2861, 2865,    0, 2869, 2873, 5946,
     1952, 2033, 5936, 2057, 2515, 5919, 3024, 2877, 5904, 3056,
     5934, 5885, 5870, 2043, 2162, 5893, 5816, 5836, 5782, 1747,
     1759, 2889, 5753, 5748, 5748, 5877,    0,    0,    0,    0,
     3127, 3066, 2279, 2351, 2408, 2471, 2506, 3110, 2533, 5752,

     2532, 5826, 5752, 5739,  126, 5757, 5774, 5750, 2046, 5751,
     5759, 3179, 2569, 2629, 2625, 2699, 2731, 3217, 2743, 5731,
     2540, 5812, 5742, 5729, 1626, 5747, 5764, 5740, 2164, 5741,
     5749,    0,    0,    0,    0,    0,    0,    0, 2881, 2805,
     1803, 2184, 2813, 2052, 2449, 2885, 2890, 5847,    0,    0,
        0, 2894, 2898, 2902, 2922, 2926,    0,    0, 2930, 2934,
     2904, 2938, 2942,    0, 2973, 2974,    0, 2978, 2982, 2986,
     5846, 5845, 5844, 2990, 5834, 5829,    0, 1955, 2488, 3343,
     3394, 1973, 2080,    0,    0,    0,    0,    0,    0, 2992,
        0, 3062, 3061, 3066,    0, 3067, 3071, 3075, 3079, 3087,

     3096, 3109, 3120, 5828, 2886, 3081, 8159, 3103, 3113, 3122,
     3134, 3135,    0, 3139, 2945, 3092, 3037, 5819, 5789, 5788,
     3146, 3183, 3208, 3226, 5778, 5777, 3090, 3159, 3094, 5776,
     5775, 3127, 5711, 5688, 3022, 5671, 3024,  471, 3063, 5677,
     5676, 5691, 5791,    0,    0, 3477, 3196, 3161, 3185, 3181,
     3200, 3210, 3460, 3216, 5667, 2756, 5748, 5678, 5663, 2525,
     5681, 5698, 5673, 3083, 5670, 5678, 3284, 3194, 3218, 3222,
     3227, 3463, 3220, 3230, 3234, 3252, 5766, 3207, 3244, 2521,
     3606, 3332, 2039, 3043, 5645, 5640, 2508, 5636, 5657, 5674,
     5640, 5676, 5643, 3358, 3244, 3271, 3466, 3265, 3497, 3258,

     3327, 3328, 3329, 5744, 3444, 3321, 2687, 5739, 3538, 2405,
     3145, 5617, 5611, 3057, 5594, 5615, 5632, 5595, 5595, 5564,
        0, 3338, 3199, 3400,    0,    0,    0,    0,    0,    0,
     3402,    0, 3406, 5679, 5678, 3412, 5673, 3416, 5649, 3446,
     5658, 3481, 3485,    0, 5628, 3506, 3508, 5596, 3570, 3463,
     3504, 5626, 5616, 5593, 5583, 3658, 5625, 3550, 3569, 5593,
     3448, 3581, 2800, 5554, 3498, 5535, 3212, 5547, 5530, 5528,
     5538, 5530, 5543, 5625,    0,    0, 3729, 3648, 3468, 3478,
     3471, 3509, 3546, 3680, 3562, 5501, 2913, 5582, 5510, 5461,
     2607, 5479, 5496, 5472, 3398, 5469, 5468, 3662, 3538, 3560,

     3570, 3552, 3643, 3550, 3560, 3630, 3633, 5553, 3638, 3625,
     3393, 3858, 3778, 2426, 3363, 5433, 5432, 3161, 5429, 5450,
     5459, 5425, 5461, 5429, 3747, 3676, 3758, 3787, 2998, 3643,
     3810, 3641, 5535, 3505, 3651, 3667, 3778, 3668, 3744, 3819,
     3674, 3910, 3705, 5535, 3691, 3727, 3766, 3956, 3890, 3808,
     3907, 5495, 5419, 5442, 5423, 2552, 1910, 5441, 5354, 5366,
     5334, 3834, 5332, 5299, 5298, 3840, 3849, 3880, 3502, 3777,
     3956, 3777, 5417, 3609, 3804, 3880, 3990, 3881, 3888, 3973,
     3889, 4052, 3947, 5410, 3928, 3954, 3973,    0, 4032, 4097,
     4101, 5353, 5277, 5300, 5277, 2556, 2090, 5285, 5243, 5231,

     5203, 3927, 5201, 5191, 5187,    0, 3870, 4030, 4075, 3762,
        0, 3964, 5271, 4015, 4038, 5237, 3999, 4086, 4093, 4098,
     4059, 5274, 4148, 4172, 5237, 4063, 4129, 4155, 5167, 5163,
     5178, 4176, 4180, 4184, 5087, 4188, 5217, 5209, 5208, 4240,
     4256, 4078, 4138, 4157, 4187, 4188, 4266, 4189, 1736, 3864,
     2477, 2614, 1993, 4103, 3207, 1285, 2556, 4051, 2819, 3961,
     4204, 4207, 4191, 4250, 4192, 4282, 4206, 4230, 4272, 4297,
     3849, 4245, 4239, 4217, 3909, 4385, 4195, 3933, 1715, 2989,
     4085, 2895, 3168, 3211, 3690, 3597, 1416, 4313, 4354, 4411,
     4148, 4243, 4417, 4293, 4099, 3766, 4356, 4357, 4410, 4331,

     4394, 4429, 4416, 4460, 4319, 2710, 4374, 4418, 4419, 5191,
     4467, 4505, 4509, 3927, 3335, 3315, 3841, 4259, 4232, 3580,
     2577, 3959, 4008, 4443, 2774, 2768, 1641, 2931, 4435, 5184,
     4451, 4452, 4203, 4546, 4432, 4428, 2975, 4464, 4481, 4472,
     4580, 4434, 4473, 4512, 4596, 3957, 4197, 3359, 3596, 4478,
     4069, 3813, 3482, 3916, 3234, 4440, 4499, 4019, 4129, 4106,
     4260, 4555, 4209, 4605, 4182, 4310, 5175, 4462, 4527, 4517,
     4651, 4560, 4573, 4583, 5125, 5000, 5001, 4960, 4932, 3614,
     4895, 4875, 4874, 4826, 4816, 4134, 4002, 4480, 4799, 4797,
     4804, 4897, 3769, 8159, 4601, 4838, 4611, 4633, 4761, 4605,

     4615, 4791, 4759, 4618, 4560, 4229, 4671, 4681, 4685, 4693,
     4697, 4705, 4709, 4713, 4717, 4722, 4725, 4814,    0,    0,
     8159, 4700, 4728, 4619,    0, 4746, 4737, 4766, 4673, 4772,
     4672, 4720, 4705, 4729, 4767, 4801, 4795, 4697, 4718, 4704,
     4700, 4639, 4657, 4655, 4630, 4486, 4640, 4623, 4589, 4575,
     4558, 4579,    0,    0, 4742, 4630, 4779, 4780, 4598, 4769,
     4839, 4849, 4530, 4482, 4423, 4853, 4857, 4861, 4454, 4534,
     8159, 4860, 4458, 4454, 4772, 4775, 4865, 4865,    0, 4881,
     4871, 4931, 4362, 4350, 4345, 4331, 4308, 4284, 4937, 4948,
     4954, 4251, 4962, 4788, 4346, 4807, 4827, 4289, 4839, 3249,

     3969, 4158, 4953, 4336, 4855, 4862, 5007, 4884, 4375, 4228,
     4210, 4229, 4986, 5029, 5035, 5041, 5047, 5053, 5059, 5065,
     5071, 5078, 5084, 5090, 5096, 5102, 5108, 5120, 4245, 4879,
     4255, 4906, 5070, 4208, 4880, 4134, 5020, 4091, 5145, 5133,
        0, 5139, 4868, 4891, 4023, 3995, 3912, 3733, 3766, 3642,
     5151, 5205, 5259, 5174, 5313, 5285, 5216, 5367, 5421, 3633,
     4941, 3679, 5078, 5133, 3600, 5075, 4449, 4489, 5168, 5080,
     5100, 4426, 4482, 4571, 3506, 5465, 5325, 5517, 5379, 5561,
     5428, 5613, 5468, 5657, 5477, 5709, 5523, 5081, 3541, 5231,
     5393, 3473, 5083, 3289, 3285, 5139, 5136, 5619, 5564, 3281,

     5173, 5660, 5715, 5180, 5736, 5742, 5247, 5750, 5756, 5142,
     3369, 5448, 5458, 3260, 5158, 4644, 4768, 4811, 4817, 5819,
     5863, 5915, 5959, 6011, 6055, 5238, 3159, 3078, 5257, 2973,
     2969, 2795, 2787, 6107, 5572, 6135, 5668, 6134, 5770, 6162,
     5780, 6214, 5805, 6242, 5866, 5373, 5452, 4712, 4554, 4803,
     4860, 5533, 5537, 5629, 5462, 2633, 2606, 2556, 4564, 4851,
     4780, 2253, 5874, 2046, 4881, 5116, 2019, 1825, 5173, 4933,
     1759, 1685, 5177, 5177, 5487, 1606, 5203, 5921, 8159, 6296,
     6307, 6318, 6329, 6340, 6351, 6362, 6373, 6384, 6395, 6406,
     6410, 6421, 6432, 6443, 6454, 6465, 6476, 6487, 6498, 6509,

     6520, 6531, 6542, 6553, 6557, 6568, 6579, 6590, 6601, 6606,
     6607, 6612, 6623, 6634, 6645, 6656, 6667, 6678, 6689, 6700,
     6711, 6722, 6733, 6744, 6755, 6766, 6777, 1554, 6788, 6799,
     6810, 6821, 6832, 6843, 6854, 6865, 1485, 6867, 6878, 6889,
     6900, 6911, 6922, 6933, 6944, 6955, 6966, 6977, 6988, 6999,
     7010, 7021, 7032, 7043, 7054, 7065, 7076, 7087, 7098, 7109,
     1340, 7111, 7122, 7133, 7144, 7155, 7166, 7177, 7188, 7199,
     7210, 7221, 7232, 7243, 7254, 7265, 7276, 7287, 7298, 7309,
     7320, 7331, 7342, 7353, 7364, 7375, 7386, 7397, 7408, 7419,
     7430, 7441, 7452, 7463, 7474, 7485, 7496, 7507, 7518, 7529,

     7540, 7551, 7562, 7573, 7584, 7595, 7606, 7617, 7628, 7639,
     7650, 7661, 7672, 7683, 7694, 7705, 7716, 7727, 7738, 7749,
     7760, 7771, 7782, 7793, 7804, 7815, 7826, 7837, 7848, 7859,
     7870, 7881, 7886, 7896, 7907, 7918, 7929, 7940, 7951, 7962,
     7973, 7984, 7995, 8006, 8017, 1297, 8028, 8039, 8050, 8061,
     8072, 8083, 8090, 8096, 8106, 1120, 8111,  516, 8121, 8132,
     8143, 8148,  184
    } ;

static const flex_int32_t yy_def[1864] =
    {   0,
     1680, 1680, 1681, 1681, 1679,    5,    5,    5, 1682, 1682,
     1679,   11, 1679,   13, 1683, 1683, 1684, 1684, 1679,   19,
     1679,   21, 1679,   23, 1685, 1685, 1686, 1686, 1687, 1687,
     1680, 1680, 1688, 1688, 1689, 1689, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1690, 1679, 1679, 1679, 1679, 1679, 1679,
     1691, 1679, 1679, 1690, 1679,   52, 1679, 1679, 1679, 1692,
     1679, 1679, 1679, 1693, 1679, 1679, 1679, 1694, 1679, 1679,
     1679, 1679, 1679, 1695, 1679, 1679, 1696, 1679, 1679, 1697,
     1679, 1679, 1698, 1679, 1690, 1679, 1679, 1679, 1679, 1679,
     1699, 1679, 1699, 1699, 1679, 1679, 1679, 1700, 1679, 1701,

     1679, 1701, 1679, 1679, 1679, 1679, 1679, 1702, 1702, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1703, 1679, 1679,
     1679, 1679, 1679, 1679, 1690, 1679, 1679, 1704, 1679, 1679,
     1679, 1679, 1705, 1679, 1679, 1706, 1679, 1704, 1679, 1707,
     1708, 1679, 1679, 1679, 1709, 1679, 1679, 1679, 1710, 1711,
     1712, 1679, 1679, 1679, 1679, 1679, 1679, 1703, 1679,  123,
      124, 1690, 1707, 1679, 1709, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1713, 1679, 1679,
     1679, 1679, 1714, 1679, 1679, 1679, 1679, 1679, 1715, 1679,
     1716, 1679, 1717, 1679, 1718, 1679, 1679, 1679, 1679, 1679,

     1719, 1679, 1679, 1679, 1679, 1690, 1679, 1679, 1679, 1679,
     1679, 1720, 1679, 1679, 1679, 1679, 1720, 1679, 1721, 1679,
     1722, 1723, 1722, 1723, 1722, 1721, 1724, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1726, 1679, 1679, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1679, 1679, 1679, 1727, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1728,
     1679, 1679, 1679, 1679, 1679, 1679, 1729, 1730, 1679, 1679,
     1679, 1729, 1729, 1729, 1679, 1679, 1731, 1679, 1732, 1732,

     1732, 1732, 1732, 1732, 1732, 1732, 1679, 1733, 1734, 1679,
     1735, 1736, 1736, 1736, 1736, 1679, 1737, 1679, 1679, 1738,
     1679, 1739, 1679, 1679, 1679, 1740, 1679, 1741, 1679, 1741,
     1741, 1741, 1741, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1732, 1732, 1732, 1736, 1736, 1736, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1742, 1742, 1743, 1742, 1742, 1742, 1742, 1679, 1679, 1744,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1744, 1745, 1745,

     1746, 1746, 1747, 1747, 1747, 1748, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1749, 1750, 1750, 1750, 1750, 1750, 1750,
     1750, 1750, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1751, 1741,
     1741, 1741, 1741, 1741, 1752, 1741, 1741, 1741, 1741, 1741,
     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1741, 1741, 1741, 1753, 1741, 1751, 1741, 1754, 1755,
     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,  479,
     1741, 1741, 1741, 1756, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1757, 1756, 1679, 1679, 1679, 1757,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1758, 1759, 1760, 1679, 1679, 1761, 1762, 1763, 1764, 1741,
     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1765,
     1741, 1741, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1766, 1766, 1766,
     1766, 1766, 1766, 1766, 1767, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1767, 1768,

     1768, 1769, 1769, 1769, 1679, 1770, 1770, 1679, 1679, 1679,
     1679, 1679, 1679, 1771, 1772, 1773, 1774, 1775, 1776, 1777,
     1679, 1679, 1679, 1741, 1741, 1741, 1778, 1778, 1778, 1741,
     1741, 1741, 1779, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1741, 1780, 1779, 1741, 1741, 1741, 1780, 1741, 1781,
     1741, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1741,
     1783, 1741, 1741, 1784, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1741, 1741, 1785, 1741, 1741, 1741, 1786, 1679, 1787,
     1788, 1789, 1679, 1679, 1679, 1679, 1679, 1790, 1791, 1679,

     1679, 1792, 1679, 1679, 1793, 1793, 1793, 1794, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1795, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1796, 1796, 1796, 1741, 1741, 1741, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1797, 1797, 1798, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1798, 1799, 1800, 1801, 1802,
     1801, 1802, 1801, 1801, 1801, 1801, 1801, 1801, 1801, 1801,

     1801, 1801, 1801, 1801, 1801, 1801, 1801, 1801, 1801, 1801,
     1801, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1803, 1804, 1805, 1806, 1807, 1808, 1809, 1679, 1741,
     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1810, 1811,
     1812, 1741, 1741, 1741, 1741, 1741, 1813, 1814, 1741, 1741,
     1815, 1741, 1741, 1816, 1816, 1816, 1817, 1741, 1741, 1741,
     1741, 1741, 1741, 1741, 1741, 1741, 1818, 1819, 1741, 1741,
     1741, 1820, 1821, 1822, 1823, 1824, 1825, 1826, 1827, 1827,
     1828, 1679, 1679, 1679, 1829, 1741, 1741, 1741, 1741, 1741,

     1741, 1741, 1741, 1741, 1741, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1830, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1830, 1831, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1833, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1834, 1741, 1741, 1741, 1835, 1836, 1837, 1838, 1839, 1840,
     1840, 1841, 1741, 1741, 1741, 1741, 1741, 1842, 1679, 1741,
     1741, 1679, 1679, 1843, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1843, 1844, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,

     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1679, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845,
     1845, 1845, 1845, 1845, 1845, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1846, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1847, 1741, 1741, 1842, 1679,
     1848, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1849, 1850, 1851, 1679, 1679, 1848, 1852, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1853, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1846,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1854, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1853, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1854, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1345, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1855, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1850, 1849, 1849, 1849,
     1850, 1850, 1850, 1851, 1851, 1851, 1679, 1679, 1852, 1852,
     1679, 1679, 1679, 1679, 1856, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1857, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1855, 1855, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1849, 1850, 1851, 1679, 1679,
     1679, 1854, 1679, 1679, 1679, 1679, 1679, 1679, 1858, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1859, 1860,
     1861, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1862, 1679, 1679, 1857, 1679, 1679, 1679,
     1679, 1679, 1860, 1859, 1859, 1859, 1859, 1859, 1860, 1860,
     1860, 1860, 1860, 1861, 1861, 1861, 1861, 1861, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1863, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1859, 1859, 1859, 1860, 1860, 1860, 1861, 1861, 1861, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1862, 1679,
     1679, 1679, 1679, 1679, 1679, 1552, 1859, 1859, 1859, 1555,
     1860, 1860, 1860, 1558, 1861, 1861, 1861, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1552, 1859, 1859, 1555, 1860, 1860, 1558, 1861, 1861, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1859,
     1552, 1860, 1555, 1861, 1558, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1859, 1859, 1576, 1859, 1860, 1860, 1580,
     1860, 1861, 1861, 1584, 1861, 1679, 1679, 1679, 1679, 1679,
     1679, 1621, 1623, 1625, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,    0, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679
    } ;

static const flex_int32_t yy_nxt[8302] =
    {   0,
     1679, 1679, 1679,   40,   41,   40,   41,   42,   42,   43,
       44,   45,   43,   42,   42,   42,   42,   42,   46,   47,
       42,   42,   42,   48,   49,   50,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   42,   52,   42,   42,   42,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
       51,   51,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   53,
       54,   55,   53,   53,   54,   55,   53,   70,   58,   58,
       84,   85,   86,   84,   42,   92,   93,   94,   42,   84,
       85,   86,   84, 1679,   87,   88,   59,   59,   92,   93,
       94,   96,   96,   87,   88,  101,  102,  624,   97,   97,
      101,  102,   71, 1569,  131,   98,   98,  131,   72,  593,

       73,  594,   56,   60,   60,  169,   56,  415,  169,  105,
      106,  107,  105,   89,  415,   90,  180,  181,  108,  182,
      208,  209,   89,   71,   90,  109,  985,  184,  986,   72,
      184,   73,   99,   99,   61,   61,   62,   62,   62,   62,
       63,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       62,   62,   62,   62,   62,   64,   64,   64,   64,   64,

       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   65,   65,
       65,   65,   66,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   67,   65,   68,   68,   68,

       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   65,   65,   65,   65,   65,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,

       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,
       70,  111,  112,  112,  111, 1507,  128,  163,  117,  118,
      119,  117,  164,  219,  128,  113,  114,  120,  121,  207,
      207,  207,  207,  122,  123,  170,  171,  172,  173,  174,
      175,  176,  228,  229, 1679,   71,  213,  214,  215,  213,
      579,   72,  933,   73,  129,  235,  236,  230,  632,  165,
      775,  220,  129,  108,  115,  105,  233,  234,  105,  131,
      109,  124,  131, 1068,  131,  296,   71,  131,  296,  775,
      296,  579,   72,  296,   73,   75,   75,   75,   75,   76,

       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   75,
       75,   75,   75,   75,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,

       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   78,   78,   78,
       78,   79,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   78,   78,   78,   78,   78,   80,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   81,
       81,   81,   81,   82,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   83,   83,

       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   81,   81,   81,   81,   81,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,  112,  125,  112,  112,  266,  308,  266,  355, 1679,
      313,  355,  155,  314,  135,  155,  126,  135,  315,  157,
      158,  159,  157, 1679,  196,  493,  113,  196,  120,  121,
      200,  201,  202,  200,  494,  160,  247,  248,  197,  198,
      247,  248,  506,  250,  222,  250,  356,  223,  309,  356,
      249,  518,  518,  507,  127,  134,  134,  135,  134,  136,
      136,  137,  138,  139,  140,  156,  141,  156,  581,  142,
      143,  135,  161,  310,  203,  441,  310,  199,  105,  106,

      107,  105,  311,  204,  678,  205,  224,  108,  250,  325,
      135,  144,  325,  346,  109,  225,  347,  251,  326,  581,
      357,  348,  252,  357,  135,  358,  145,  146,  358, 1472,
      147,  134,  144,  134,  134,  148,  149,  224,  144, 1679,
      359,  150,  144,  359,  151,  152,  134, 1679,  134,  153,
      135,  134,  144,  154,  144,  238,  134,  134,  135,  253,
     1679, 1679,  239,  111,  112,  112,  111,  240,  508,  508,
      509,  241,  242,  243,  439,  244, 1679,  113,  114,  112,
      112,  112,  112,  135,  254,  255,  256,  254,  163,  360,
      245,  135,  360,  164,  126,  259,  118,  260,  259,  126,

      658,  135,  494,  246,  261,  262,  112,  118,  112,  112,
      263,  264,  440,  548,  155,  135,  115,  155,  766,  361,
      184,  126,  361,  184,  117,  118,  119,  117,  113,  630,
      342, 1679,  127,  120,  121,  184,  653,  257,  184,  122,
      123,  879,  327,  328,  329,  327,  525,  525,  265,  298,
      298,  298,  298,  298,  298,  298,  298,  767,  300,  127,
      267,  268,  301,  267,  302,  303,  196,  156,  210,  196,
      304,  210,  328,  530,  135,  305,  269,  124,  306, 1679,
      197,  198,  135,  350,  351,  352,  353,  270,  207,  207,
      207,  207, 1421,  271,  272,  156, 1679,  273, 1679,  274,

      649,  275,  629,  276,  277,  278, 1375,  279,  354,  280,
      442,  354, 1679,  129,  207,  207,  207,  207,  281,  199,
      282,  199,  283,  555,  555,  284,  350,  351,  352,  353,
      285,  368,  368,  368,  368,  286,  134,  134,  135,  134,
      136,  136,  137,  287,  139,  140,  369,  288,  443,  318,
      289,  143,  135,  323,  723,  323, 1679,  324,  324,  324,
      324,  324,  324,  324,  324,  324,  846,  330,  158,  331,
      330,  421,  144, 1679,  421, 1015,  261,  262,  379,  379,
      379,  379,  414,  332,  726,  414,  370,  290,  146,  370,
      523,  147,  134,  144,  134,  134,  148,  149,  432,  144,

     1679,  198,  150,  144, 1679,  151,  152,  134,  684,  134,
      153,  135,  134,  144,  154,  144,  415,  134,  134,  135,
      333,  334,  335, 1421,  336,  415,  337,  157,  158,  159,
      157,  378,  556,  556,  338,  339,  120,  121,  300,  199,
      636,  340,  343,  160,  302,  344,  372,  373,  374,  372,
      345,  378,  727,  404,  423,  305,  502,  423,  306,  502,
      228,  229,  378,  200,  201,  202,  200,  595,  596, 1679,
      341,  213,  381,  382,  213,  230,  383,  384,  385,  383,
      161,  405,  378,  213,  214,  215,  213,  769,  267,  268,
      375,  267,  405,  414,  526,  407,  414,  408,  405,  376,

     1679,  377,  386,  387,  228,  229,  409,  203,  410,  640,
      411,  388,  405,  622,  622,  389,  204,  412,  205,  230,
      416,  390,  529,  405,  235,  236,  770,  415,  296,  405,
      432,  296,  108,  419,  419, 1205,  416,  557,  415,  109,
      557,  391,  417,  413,  419,  419,  423,  247,  248,  423,
      419,  419,  425,  623,  623,  426,  428,  247,  248,  428,
      427,  714,  714,  503,  419,  419,  429,  558,  528,  430,
      558,  424,  432,  652,  431,  419,  419,  254,  255,  256,
      254,  419,  419,  433,  255,  434,  433,  112,  255,  112,
      112, 1679,  126, 1679,  135,  768,  495,  559,  435,  495,

      559,  251,  126,  392,  393,  394,  291,  486,  135,  250,
      486,  395,  486,  396,  397,  486,  437,  112,  433,  437,
      433,  118,  433,  433,  310,  496,  768,  310, 1679,  428,
      257,  435,  428,  311,  572,  435,  436,  497, 1679,  489,
      127,  487,  487,  253,  424,  498, 1679,  500, 1421,  487,
      487,  487, 1679,  490,  572,  489,  776,  500,  500,  499,
      442,  491,  487,  512,  500,  572,  513,  135,  500,  438,
      729,  514,  730,  436,  500,  135,  444,  268,  500,  444,
      560,  561,  250,  560,  561,  572,  511,  428,  500,  500,
      428,  325,  445,  552,  325,  500,  553,  641,  443,  500,

      326,  554,  424,  446,  354,  500,  642,  354,  905,  447,
      448,  464, 1679,  449,  464,  450,  879,  451,  777,  452,
      453,  454, 1421,  455,  355,  456, 1012,  355, 1013,  440,
      327,  328,  329,  327,  457, 1679,  458, 1677,  459,  356,
      250,  460,  356, 1421,  357,  358,  461,  357,  358,  746,
      746,  462,  134,  463,  464,  463,  465,  465,  466,  467,
      468,  469,  359,  470,  531,  359,  471,  472,  464,  324,
      324,  324,  324,  324,  324,  324,  324,  324,  360,  361,
     1391,  360,  361,  156,  368,  368,  368,  368,  473,  368,
      368,  368,  368,  772,  372,  373,  374,  372,  379,  379,

      379,  379,  414,  474,  475,  414, 1679,  476,  463,  473,
      463,  463,  477,  478,  897,  473, 1674,  486,  479,  473,
      486,  480,  481,  463, 1679,  463,  482,  464,  463,  473,
      483,  473,  767,  463,  463,  464,  444,  268,  375,  444,
      370,  414,  569,  370,  414,  569, 1196,  376,  935,  377,
      615,  487,  445,  615,  936,  198,  616,  570,  617,  616,
      487,  617,  532,  533, 1007,  534,  773,  535,  618,  447,
      448,  618,  935,  449,  936,  536,  537,  451, 1679,  452,
      453,  454,  538,  455,  619,  456, 1022,  619,  654,  440,
     1673,  500,  544,  199,  457,  571,  458,  545,  459,  655,

      620,  460,  500,  620,  423,  770,  461,  423,  500,  778,
      779,  539,  134,  463,  464,  463,  465,  465,  466,  467,
      468,  540,  500,  470,  874,  874,  541,  472,  464,  621,
      551,  428,  621,  500,  428,  604,  605,  604,  604,  500,
      603, 1679,  905,  464,  631, 1679,  486,  631,  473,  486,
      625,  444,  268, 1679,  444,  624, 1670,  464,  523,  433,
      112,  433,  433,  542,  475, 1679, 1035,  476,  463,  473,
      463,  463,  477,  478,  435,  473,  528, 1679,  479,  473,
     1037,  480,  481,  463,  915,  463,  482,  464,  463,  473,
      483,  473,  626,  463,  463,  464,  383,  576,  577,  383,

     1421,  383,  576,  577,  383, 1351,  433,  255,  433,  433,
      650,  690,  436,  650,  690,  916,  464,  578,  384,  385,
      578,  435,  386,  387,  464, 1351,  582,  386,  387,  643,
     1679,  388,  643,  879,  879,  389,  388,  656,  656,  657,
      389,  390,  486,  386,  387,  486,  390,  689,  437,  112,
      433,  437,  388,  583, 1679, 1679,  389,  584,  644,  436,
     1679,  391,  390,  435,  904,  904,  391,  585,  634, 1679,
      645,  634,  634, 1679,  917,  634,  673, 1679,  486,  673,
      586,  486,  391,  529,  587,  674,  635,  691,  584,  646,
      691, 1038, 1679,  635,  464, 1679,  932,  464,  588,  637,

     1679,  438,  635,  647,  692,  917, 1152,  692, 1679,  687,
     1679,  635,  687,  638,  675,  637,  693,  676,  688,  693,
     1011,  639,  677,  392,  393,  394,  635,  932,  392,  393,
      394,  395,  648,  396,  397, 1023,  395,  635,  396,  397,
      648,  990,  991,  648,  392,  393,  394,  531,  762,  648,
     1669,  648,  395,  589,  396,  397,  694,  648,  663,  694,
      905,  905,  664,  648,  665,  666,  695,  762, 1153,  695,
      667,  648, 1679,  495,  648,  668,  495, 1666,  669,  659,
      648, 1679,  648,  672, 1679, 1381,  672, 1679,  648,  661,
      661,  661,  661,  661,  661,  661,  661,  696,  632,  697,

      696,  698,  697,  768,  698, 1381,  651,  651,  651,  651,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,
      651,  651,  699, 1679,  768,  699,  443, 1679,  700,  701,
      702,  700,  701,  702,  703,  704,  679,  703,  704,  708,
      709, 1022,  708,  709,  680,  680,  680,  680,  710, 1017,
     1018,  710,  680,  680,  680,  680,  680,  680,  680,  680,
      680,  680,  680,  680,  680,  680,  680,  680,  680,  680,
      680,  680,  680,  680,  680,  680,  680,  680, 1679,  711,
      712,  713,  711,  715,  716,  738,  715,  716,  738,  740,

      741,  642,  740,  741,  742,  743,  744,  742,  743,  744,
      967, 1679,  728,  681,  681,  681,  681,  681,  681,  681,
      681,  681,  681,  681,  681,  681,  681,  681,  681,  681,
      681,  681,  681,  681,  681,  681,  681,  681,  681,  745,
      711,  967,  745,  711,  681,  681,  681,  681,  681,  681,
      681,  681,  681,  681,  681,  681,  681,  681,  681,  681,
      681,  681,  681,  681,  681,  681,  681,  681,  681,  681,
      682,  735,  557,  558,  736,  557,  558,  559,  560,  737,
      559,  560,  561,  968, 1665,  561,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,

      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  753,  617,  968,  753,  617,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683, 1679,  634, 1679,  573,  634,  969,  573,
      706, 1679, 1679,  706, 1679,  685,  464,  685, 1679,  686,
      686,  686,  686,  686,  686,  686,  686,  686,  707,  663,
      464,  751, 1192,  732,  751,  665,  733,  569,  635,  969,
      569,  734,  762,  648, 1421,  621,  668,  635,  621,  669,
      752, 1679,  570, 1314,  648,  755,  368,  755,  755,  571,

      648,  578,  576,  577,  578,  763,  578,  576,  577,  578,
      756,  970, 1679,  762,  648,  707, 1023,  716,  840,  724,
      716,  841,  731, 1010,  725,  648,  842,  386,  387,  464,
      571,  648,  386,  387, 1193,  774,  388,  464,  971,  584,
      389,  388,  970,  583, 1036,  389,  390,  758,  759,  760,
      758,  390,  774,  672, 1679, 1315,  672,  585,  584,  631,
     1679,  979,  631, 1421,  847, 1679,  391,  847,  632,  971,
      693,  391,  843,  693,  587,  844,  634, 1679,  764,  634,
      845,  848,  634, 1679, 1421,  634,  849, 1679,  588,  849,
      634, 1679,  979,  634,  850, 1679,  981,  850,  851, 1679,

      994,  851,  852, 1679, 1008,  852,  443,  853, 1679,  982,
      853,  854, 1679, 1147,  854,  643, 1679, 1009,  643,  855,
     1679, 1421,  855,  856, 1679, 1116,  856, 1117,  392,  393,
      394,  994, 1147,  392,  393,  394,  395,  694,  396,  397,
      694,  395, 1158,  396,  397,  791,  605,  791,  791, 1159,
      792,  857, 1679, 1350,  857,  858, 1679, 1380,  858,  859,
     1679,  995,  859,  860, 1679,  996,  860,  861, 1679, 1016,
      861,  793,  794,  862, 1679,  865,  862, 1350,  865,  795,
      796, 1380,  695,  797,  798,  695,  799, 1661,  863, 1679,
      800,  863,  995,  866,  867, 1679,  996,  867,  801,  868,

     1679, 1383,  868,  869, 1679,  696,  869, 1279,  696, 1280,
      802,  870,  712,  871,  870,  672, 1679, 1421,  672,  673,
     1679, 1372,  673,  687, 1679, 1679,  687,  697,  674,  822,
      697,  700,  688,  701,  700,  890,  701, 1660,  890,  997,
      866,  686,  686,  686,  686,  686,  686,  686,  686,  686,
      703,  704,  706,  703,  704,  706,  706,  709,  710,  706,
      709,  710,  711,  998, 1659,  711,  892,  712,  713,  892,
      997, 1006,  803,  804,  805, 1421,  806,  807,  808, 1187,
      809, 1421,  810,  811,  605,  605,  605,  605,  715,  812,
      716,  715,  894,  716,  998,  894,  896, 1679, 1187,  896,

      898, 1679, 1006,  898,  899, 1679,  738,  899, 1679,  738,
      813,  814,  900, 1679,  906,  900, 1679,  906,  815,  816,
     1112,  740,  817,  818,  740,  819, 1421,  901, 1679,  820,
      901,  902, 1679, 1113,  902,  903, 1679,  821,  903,  870,
     1679,  741,  870,  742,  741,  743,  742,  744,  743,  822,
      744,  745,  909,  751,  745,  909,  751,  911,  753,  912,
      911,  753,  912,  755,  368,  755,  755,  755,  368,  755,
      755,  758,  759,  760,  758,  914, 1022, 1022,  914,  758,
      759,  760,  758,  894, 1023, 1023,  894, 1024, 1679, 1679,
     1024,  937,  847, 1679,  937,  847,  852, 1679, 1227,  852,

      853, 1679, 1421,  853,  854, 1679, 1031,  854, 1390, 1031,
     1389,  823,  824,  825, 1228,  826,  827,  828, 1651,  829,
     1227,  830,  831, 1679,  855, 1679, 1650,  855,  856, 1679,
     1019,  856,  859, 1679, 1126,  859,  860, 1679, 1421,  860,
      862, 1679, 1041,  862,  863, 1679, 1045,  863,  880,  880,
      880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
      880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
      880,  880,  880,  880, 1679,  865,  865, 1275,  865,  865,
      868, 1679, 1421,  868,  869, 1679, 1431,  869,  870, 1679,
     1276,  870, 1033, 1679,  890, 1033, 1421,  890, 1046,  881,

      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  920,  938,  939, 1200, 1047,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  921,  926,  758,  759,
      760,  758, 1333,  894,  892,  922,  894,  892,  894,  896,
     1679,  894,  896, 1040, 1679, 1334, 1040,  898, 1679, 1049,
      898,  899, 1679,  906,  899,  927,  906,  923,  921,  900,
     1679, 1057,  900, 1048,  793,  794,  924,  922,  901, 1679,

     1649,  901,  795,  796, 1648, 1042,  797,  798, 1042,  799,
     1049,  902, 1679,  800,  902,  909,  928, 1039,  909,  923,
     1197,  801,  903, 1679, 1043,  903,  584, 1043,  924,  946,
      605,  946,  946,  802,  947, 1058,  911,  912,  972,  911,
      912,  914,  973, 1647,  914, 1046,  974, 1052,  758,  759,
      760,  758,  975, 1063, 1064,  948,  949,  584,  976, 1061,
     1060, 1066, 1067,  950,  951,  977, 1059,  952,  953,  972,
      954, 1069, 1070,  973,  955, 1421, 1047,  974, 1121, 1122,
     1154, 1155,  956,  975, 1053,  758,  759,  760,  758,  976,
     1061, 1198, 1098, 1646,  957,  803,  804,  805, 1199,  806,

      807,  808, 1679,  809, 1058,  810,  811,  813,  814, 1054,
      758,  759,  760,  758, 1421,  815,  816, 1099, 1421,  817,
      818, 1100,  819, 1098, 1079, 1080,  820, 1055,  758,  759,
      760,  758, 1081, 1082,  821, 1059, 1083, 1084,  978, 1085,
     1101, 1421, 1102, 1086, 1110,  999,  822, 1130, 1099, 1000,
     1131, 1087, 1100, 1001, 1132, 1207,  958,  959,  960, 1002,
      961,  962,  963, 1088,  964, 1003,  965,  966, 1135, 1140,
     1141, 1101, 1004, 1102, 1142, 1110,  999, 1133, 1130, 1201,
     1000, 1131, 1194, 1195, 1001, 1132, 1125, 1126, 1127, 1125,
     1002, 1128, 1143, 1146, 1145, 1320, 1003, 1170, 1104, 1135,

     1140, 1141, 1321, 1171, 1202, 1142, 1175, 1180,  823,  824,
      825, 1145,  826,  827,  828, 1014,  829, 1104,  830,  831,
     1231, 1070, 1421, 1143, 1146, 1089, 1090, 1091, 1170, 1092,
     1093, 1094, 1629, 1095, 1171, 1096, 1097, 1175, 1180, 1129,
     1033, 1679, 1421, 1033, 1536, 1005, 1679, 1150, 1444, 1150,
     1134, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151,
     1166, 1126, 1167, 1166, 1536, 1168, 1421, 1181, 1182, 1183,
     1186,  680,  680,  680,  680,  680,  680,  680,  680,  680,
      680,  680,  680,  680,  680,  680,  680,  680,  680,  680,
      680,  680,  680,  680,  680,  680,  680, 1679, 1181, 1182,

     1183, 1186, 1024, 1679, 1031, 1024, 1378, 1031, 1033, 1679,
     1626, 1033, 1619, 1169, 1208, 1679, 1617, 1208,  432,  895,
     1616,  432,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683, 1040, 1679,
     1192, 1040, 1437,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683,  683,
      683,  683,  683,  683,  683,  683,  683,  683,  683, 1077,
      605, 1077, 1077, 1042, 1078, 1309, 1042, 1043, 1103, 1421,
     1043, 1136, 1104, 1284, 1285,  762, 1105, 1049, 1172, 1261,

     1316, 1317, 1106, 1137, 1309, 1079, 1080, 1213, 1107, 1216,
     1262, 1263, 1138, 1081, 1082, 1108, 1139, 1083, 1084, 1103,
     1085, 1173, 1136, 1104, 1086, 1176,  762, 1105, 1049, 1172,
     1261, 1185, 1087, 1106, 1137, 1000,  921, 1177, 1214, 1107,
     1214, 1262, 1263, 1138, 1088,  922, 1178, 1139, 1185, 1264,
     1179, 1222, 1615, 1190, 1000, 1190, 1176, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1363,  923, 1177, 1215,
     1225, 1215,  758,  759,  760,  758,  924, 1178, 1265, 1364,
     1264, 1179, 1223,  758,  759,  760,  758, 1421, 1109, 1610,
     1273, 1292, 1293, 1297, 1174, 1180, 1294, 1229, 1230, 1302,

     1303, 1223, 1294, 1421, 1421, 1442, 1089, 1090, 1091, 1265,
     1092, 1093, 1094, 1224, 1095, 1294, 1096, 1097, 1148, 1229,
     1230, 1273, 1292, 1293, 1297, 1295, 1149, 1149, 1149, 1149,
     1302, 1303, 1224, 1294, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
      758,  759,  760,  758, 1288, 1126, 1289, 1288, 1382, 1290,
     1304, 1298, 1593, 1305, 1308, 1335, 1242, 1243, 1329, 1126,
     1330, 1329, 1336, 1299, 1244, 1245, 1204,  927, 1246, 1247,
      921, 1248, 1300, 1302, 1331, 1249, 1301, 1421, 1296,  922,

     1172, 1304, 1298, 1250, 1305, 1308, 1335, 1302, 1266, 1302,
     1302, 1437, 1267, 1336, 1299, 1251, 1268, 1291,  928, 1172,
     1588,  923, 1269, 1300, 1302, 1307, 1491, 1301, 1270, 1267,
      924, 1240,  605, 1240, 1240, 1271, 1241, 1302, 1302, 1266,
     1302, 1302, 1307, 1267, 1343, 1438, 1439, 1268, 1267, 1288,
     1126, 1328, 1288, 1269, 1290, 1344, 1180, 1242, 1243, 1270,
     1332, 1126, 1328, 1332, 1393, 1244, 1245, 1393, 1302, 1246,
     1247, 1393, 1248, 1421, 1393, 1343, 1249, 1252, 1253, 1254,
     1338, 1255, 1256, 1257, 1250, 1258, 1344, 1259, 1260, 1332,
     1126, 1289, 1332, 1312, 1339, 1312, 1251, 1313, 1313, 1313,

     1313, 1313, 1313, 1313, 1313, 1313, 1302, 1302, 1272, 1365,
     1302, 1338, 1288, 1126, 1289, 1288, 1203, 1290, 1366, 1302,
     1421, 1288, 1126, 1289, 1288, 1339, 1290, 1313, 1313, 1313,
     1313, 1313, 1313, 1313, 1313, 1313, 1356, 1302, 1302, 1356,
     1365, 1302, 1166, 1126, 1330, 1166, 1180, 1168, 1421, 1366,
     1302, 1362, 1126, 1330, 1362, 1180, 1421, 1172, 1252, 1253,
     1254, 1184, 1255, 1256, 1257, 1291, 1258, 1575, 1259, 1260,
     1310, 1421, 1208, 1679, 1291, 1208, 1172, 1180, 1311, 1311,
     1311, 1311, 1362, 1126, 1167, 1362, 1311, 1311, 1311, 1311,
     1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,

     1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311, 1311,
     1311, 1311, 1288, 1126, 1289, 1288, 1421, 1290, 1242, 1243,
     1180, 1188, 1180, 1421, 1368, 1180, 1244, 1245, 1008, 1386,
     1246, 1247, 1386, 1248, 1421, 1242, 1243, 1249, 1369, 1340,
     1421, 1009, 1341, 1244, 1245, 1346, 1441, 1246, 1247, 1379,
     1248, 1180, 1302, 1180, 1249, 1368, 1180, 1251, 1166, 1126,
     1167, 1166, 1347, 1168, 1421, 1291, 1421,  994, 1421, 1369,
     1340, 1357, 1358, 1341, 1251, 1166, 1126, 1167, 1166, 1180,
     1168, 1373, 1374, 1302, 1345, 1345, 1345, 1345, 1345, 1345,
     1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345,

     1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345, 1345,
     1180, 1169, 1373, 1374, 1180, 1421, 1396, 1046, 1180, 1252,
     1253, 1254, 1180, 1255, 1256, 1257, 1421, 1258, 1169, 1259,
     1260, 1180, 1208, 1679, 1435, 1208, 1252, 1253, 1254, 1399,
     1255, 1256, 1257, 1574, 1258, 1180, 1259, 1260, 1047, 1180,
     1443, 1397, 1046, 1180, 1166, 1126, 1167, 1166, 1421, 1168,
      813,  814, 1180, 1020, 1387, 1388, 1537, 1384,  815,  816,
     1194, 1195,  817,  818, 1397,  819, 1421,  432,  895,  820,
      432, 1370, 1398, 1047, 1371, 1421, 1537, 1376,  758,  759,
      760,  758, 1421, 1378, 1180,  758,  759,  760,  758,  822,

      758,  759,  760,  758, 1058, 1398, 1421, 1169, 1058,  994,
     1421, 1367, 1370, 1421, 1447, 1371, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1180, 1573, 1448, 1449,  813,
      814,  758,  759,  760,  758, 1059, 1421,  815,  816, 1059,
      994,  817,  818, 1385,  819, 1421, 1017, 1018,  820, 1402,
      758,  759,  760,  758, 1572, 1421, 1377,  758,  759,  760,
      758,  823,  824,  825, 1421,  826,  827,  828,  822,  829,
      995,  830,  831, 1403,  758,  759,  760,  758, 1409,  759,
     1410, 1409, 1412,  759, 1413, 1412, 1415,  759, 1416, 1415,
      758,  759,  760,  758, 1421, 1421, 1421,  996, 1421, 1421,

     1440,  995, 1421, 1012, 1421, 1013, 1166, 1126, 1167, 1166,
     1421, 1423, 1363, 1421, 1421, 1425, 1679, 1006, 1429, 1198,
      998, 1425, 1568, 1171, 1421, 1364, 1199,  997,  996, 1451,
      823,  824,  825, 1175,  826,  827,  828, 1421,  829, 1421,
      830,  831,  605,  605,  605,  605, 1421, 1422, 1006, 1429,
     1421,  998, 1421, 1450, 1171, 1180, 1538, 1421,  997, 1169,
     1170, 1436, 1192, 1421, 1175, 1567, 1421, 1421,  813,  814,
     1181, 1445, 1446, 1421, 1566, 1365,  815,  816, 1538, 1421,
      817,  818, 1172,  819,  813,  814, 1180,  820, 1186, 1421,
     1561, 1170,  815,  816,  999,  821,  817,  818, 1000,  819,

     1421, 1181, 1001,  820, 1421, 1173, 1365,  822, 1002, 1187,
     1176,  821, 1182, 1172, 1003, 1166, 1126, 1330, 1166, 1186,
     1423, 1004, 1177,  822, 1193,  999, 1421, 1381, 1187, 1000,
     1465, 1178, 1185, 1001, 1366, 1179, 1000, 1183, 1421, 1002,
     1560, 1176, 1550, 1182, 1549, 1003, 1548, 1381, 1541, 1185,
     1535, 1180, 1430, 1177, 1465, 1000, 1362, 1126, 1330, 1362,
     1380, 1421, 1178, 1421, 1421, 1366, 1179, 1452, 1183,  823,
      824,  825, 1180,  826,  827,  828, 1530,  829, 1174,  830,
      831, 1421, 1180, 1430, 1380,  823,  824,  825, 1529,  826,
      827,  828, 1421,  829, 1005,  830,  831, 1180, 1180, 1513,

     1190, 1421, 1190, 1180, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1362, 1126, 1167, 1362, 1421, 1421, 1166,
     1126, 1167, 1166, 1421, 1423, 1421, 1421, 1373, 1180, 1180,
     1368, 1166, 1126, 1167, 1166, 1421, 1423, 1329, 1180, 1421,
     1329, 1421, 1180, 1512, 1369, 1386, 1374, 1421, 1386, 1511,
     1421, 1180, 1180, 1331, 1362, 1126, 1330, 1362, 1373, 1421,
     1180, 1368, 1166, 1126, 1167, 1166, 1000, 1423, 1429, 1180,
     1430, 1421, 1169, 1180, 1421, 1369, 1547, 1374, 1510, 1421,
     1421, 1509, 1180, 1180, 1169, 1421, 1424, 1424, 1421, 1370,
     1424, 1180, 1371, 1508, 1424,  813,  814, 1000, 1424, 1429,

     1547, 1430, 1180,  815,  816, 1433, 1421,  817,  818, 1180,
      819, 1171, 1421, 1171,  820, 1169, 1421, 1432, 1504, 1421,
     1370, 1598, 1376, 1371, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1180,  822, 1503, 1433,  813,  814, 1470,
     1180, 1598, 1171, 1434, 1171,  815,  816, 1234, 1432,  817,
      818, 1594,  819, 1421, 1502, 1180,  820, 1362, 1126, 1330,
     1362, 1427, 1432, 1427, 1377, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1434, 1594,  822, 1445, 1446, 1599,
     1387, 1388, 1166, 1126, 1167, 1166, 1180, 1423, 1448, 1449,
     1378, 1595, 1000, 1432, 1488, 1449,  823,  824,  825, 1599,

      826,  827,  828, 1421,  829, 1433,  830,  831, 1679, 1438,
     1439, 1447, 1456, 1501, 1434, 1595, 1679, 1679, 1679, 1679,
     1427, 1180, 1427, 1000, 1428, 1428, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1214, 1459, 1169, 1433, 1214,  823,  824,
      825, 1457,  826,  827,  828, 1434,  829, 1223,  830,  831,
     1223, 1656, 1180, 1166, 1126, 1167, 1166, 1463, 1168, 1662,
     1464, 1500, 1471, 1457, 1215, 1499, 1494, 1493, 1215, 1600,
     1493, 1656, 1458, 1412,  759, 1413, 1412, 1463, 1224, 1662,
     1492, 1224, 1464, 1466,  759, 1410, 1466, 1466,  759, 1410,
     1466, 1600, 1180, 1471, 1458, 1466,  759, 1410, 1466, 1467,

      759, 1413, 1467, 1475, 1172, 1491, 1169, 1467,  759, 1413,
     1467, 1467,  759, 1413, 1467, 1468,  759, 1416, 1468, 1468,
      759, 1416, 1468, 1180, 1468,  759, 1416, 1468,  813,  814,
     1362, 1126, 1167, 1362, 1475, 1172,  815,  816, 1490, 1489,
      817,  818, 1447,  819, 1630, 1487, 1180,  820, 1166, 1126,
     1167, 1166, 1180, 1168, 1430,  821, 1428, 1428, 1428, 1428,
     1428, 1428, 1428, 1428, 1428, 1476, 1630,  822, 1166, 1126,
     1167, 1166, 1486, 1168, 1166, 1126, 1167, 1166, 1397, 1168,
     1495, 1498, 1477, 1180, 1477, 1430, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1478, 1481, 1476, 1166, 1126, 1167,

     1166, 1473, 1168, 1483, 1484, 1397, 1485, 1505, 1531, 1398,
     1655, 1482, 1482, 1479, 1496, 1496, 1506, 1481, 1457, 1470,
     1469, 1474, 1462, 1461, 1460, 1483, 1484, 1169, 1534,  823,
      824,  825, 1655,  826,  827,  828, 1398,  829, 1505,  830,
      831,  758,  759,  760,  758, 1497, 1497, 1506, 1532, 1458,
     1169,  758,  759,  760,  758, 1466,  759, 1410, 1466, 1467,
      759, 1413, 1467, 1468,  759, 1416, 1468, 1679, 1532, 1457,
     1455, 1631, 1679, 1166, 1126, 1167, 1166, 1664, 1168, 1533,
     1679, 1679, 1679, 1679, 1478, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478,  813,  814, 1631, 1543, 1664, 1544, 1533,

     1458,  815,  816, 1657, 1454,  817,  818, 1562,  819,  813,
      814, 1452,  820, 1632, 1496, 1496, 1570,  815,  816, 1633,
     1451,  817,  818, 1450,  819, 1657, 1169, 1543,  820, 1544,
     1444, 1571,  822, 1166, 1126, 1167, 1166, 1632, 1168, 1515,
     1126, 1516, 1515, 1633, 1517, 1497, 1497, 1570,  822, 1663,
     1520, 1126, 1521, 1520, 1563, 1522, 1525, 1126, 1526, 1525,
     1443, 1527, 1571, 1658, 1166, 1126, 1167, 1166, 1539, 1168,
     1539, 1663, 1540, 1540, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1545, 1532, 1667, 1546, 1564, 1169, 1658, 1520, 1126,
     1521, 1520, 1518, 1522,  823,  824,  825, 1442,  826,  827,

      828, 1545,  829, 1523,  830,  831, 1546, 1667, 1441, 1528,
      823,  824,  825, 1533,  826,  827,  828, 1169,  829, 1679,
      830,  831,  758,  759,  760,  758, 1440, 1679, 1679, 1679,
     1679, 1551, 1126, 1516, 1551, 1672, 1517, 1551, 1126, 1516,
     1551, 1523, 1517, 1551, 1126, 1516, 1551, 1437, 1517, 1551,
     1126, 1516, 1551, 1437, 1517, 1551, 1126, 1516, 1551, 1672,
     1517, 1554, 1126, 1521, 1554, 1436, 1522, 1554, 1126, 1521,
     1554, 1565, 1522, 1554, 1126, 1521, 1554, 1435, 1522, 1589,
     1554, 1126, 1521, 1554, 1518, 1522, 1554, 1126, 1521, 1554,
     1518, 1522, 1557, 1126, 1526, 1557, 1518, 1527, 1557, 1126,

     1526, 1557, 1518, 1527, 1557, 1126, 1526, 1557, 1518, 1527,
     1557, 1126, 1526, 1557, 1523, 1527, 1532, 1552, 1563, 1590,
     1523, 1596, 1557, 1126, 1526, 1557, 1523, 1527, 1597, 1563,
     1553, 1563, 1679, 1523, 1592, 1166, 1126, 1167, 1166, 1523,
     1168, 1166, 1126, 1167, 1166, 1528, 1168, 1533, 1555, 1564,
     1591, 1528, 1596, 1551, 1126, 1516, 1551, 1528, 1517, 1597,
     1564, 1556, 1564, 1528, 1540, 1540, 1540, 1540, 1540, 1540,
     1540, 1540, 1540, 1180, 1590, 1528, 1554, 1126, 1521, 1554,
     1679, 1522, 1180, 1590, 1558, 1514, 1431, 1126, 1679, 1679,
     1679, 1679, 1519, 1514, 1514, 1514, 1514, 1559, 1421, 1590,

     1519, 1519, 1519, 1519, 1180, 1591, 1518, 1551, 1126, 1516,
     1551, 1668, 1517, 1180, 1591, 1421, 1420, 1576, 1557, 1126,
     1526, 1557, 1418, 1527, 1417, 1577, 1577, 1577, 1577, 1523,
     1591, 1668, 1611, 1577, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1577, 1524,
     1518, 1551, 1126, 1516, 1551, 1612, 1517, 1524, 1524, 1524,
     1524, 1528, 1612, 1671, 1578, 1675, 1578, 1676, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1579, 1579, 1554, 1126, 1521,
     1554, 1612, 1522, 1407, 1406, 1671, 1613, 1675, 1405, 1676,

     1582, 1678, 1582, 1613, 1583, 1583, 1583, 1583, 1583, 1583,
     1583, 1583, 1583, 1404, 1518, 1554, 1126, 1521, 1554, 1401,
     1522, 1400, 1613, 1678, 1395, 1580, 1391, 1551, 1126, 1516,
     1551, 1390, 1517, 1581, 1581, 1581, 1581, 1389, 1385, 1384,
     1523, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1383, 1523, 1557,
     1126, 1526, 1557, 1382, 1527,  758,  759,  760,  758, 1584,
     1602, 1551, 1126, 1516, 1551, 1379, 1517, 1585, 1585, 1585,
     1585, 1378, 1192,  994, 1614, 1585, 1585, 1585, 1585, 1585,

     1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585,
     1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585, 1585,
     1585, 1372, 1528, 1557, 1126, 1526, 1557, 1612, 1527, 1367,
     1554, 1126, 1521, 1554, 1603, 1522, 1586, 1361, 1586, 1360,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1587, 1627,
      758,  759,  760,  758,  758,  759,  760,  758, 1613, 1628,
      758,  759,  760,  758,  758,  759,  760,  758, 1359, 1355,
     1554, 1126, 1521, 1554, 1354, 1522, 1528, 1514, 1353, 1557,
     1126, 1526, 1557, 1605, 1527, 1514, 1514, 1514, 1514,  758,
      759,  760,  758, 1601, 1601, 1601, 1601, 1601, 1601, 1601,

     1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601,
     1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601, 1551,
     1126, 1516, 1551, 1606, 1517, 1557, 1126, 1526, 1557, 1352,
     1527, 1349, 1608, 1348, 1314, 1261, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1514, 1342, 1337, 1327, 1519,
     1326, 1325, 1324, 1514, 1514, 1514, 1514, 1519, 1519, 1519,
     1519, 1323, 1322, 1319, 1318, 1306, 1166, 1126, 1167, 1166,
     1287, 1168, 1518, 1519, 1551, 1126, 1516, 1551, 1609, 1517,
     1286, 1519, 1519, 1519, 1519, 1283, 1282, 1281, 1278, 1604,
     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,

     1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1604, 1604, 1604, 1604, 1554, 1126, 1521, 1554, 1169,
     1522, 1166, 1126, 1167, 1166, 1251, 1168, 1603, 1277, 1274,
     1237, 1236, 1583, 1583, 1583, 1583, 1583, 1583, 1583, 1583,
     1583, 1524, 1236, 1235, 1234, 1233, 1232, 1068, 1228, 1524,
     1524, 1524, 1524, 1226, 1221, 1220, 1219,  768, 1218, 1217,
     1212, 1679, 1551, 1126, 1516, 1551, 1210, 1517, 1523, 1524,
     1551, 1126, 1516, 1551, 1169, 1517, 1679, 1524, 1524, 1524,
     1524, 1679, 1679, 1205, 1204, 1607, 1607, 1607, 1607, 1607,
     1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607,

     1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607, 1607,
     1607, 1557, 1126, 1526, 1557, 1518, 1527, 1551, 1126, 1516,
     1551, 1203, 1517, 1602, 1552, 1202, 1201, 1200, 1587, 1587,
     1587, 1587, 1587, 1587, 1587, 1587, 1587, 1620, 1554, 1126,
     1521, 1554, 1197, 1522, 1554, 1126, 1521, 1554, 1196, 1522,
     1618, 1188, 1557, 1126, 1526, 1557, 1184, 1527, 1557, 1126,
     1526, 1557, 1165, 1527, 1528, 1164, 1163, 1162, 1161, 1160,
     1518, 1157, 1554, 1126, 1521, 1554, 1156, 1522, 1144, 1621,
     1124, 1123, 1554, 1126, 1521, 1554, 1120, 1522, 1119, 1118,
     1115, 1523, 1553, 1088, 1114, 1111, 1074, 1523, 1073, 1072,

     1555, 1071, 1065, 1062, 1062, 1528, 1623, 1557, 1126, 1526,
     1557, 1528, 1527, 1622, 1558,  770,  767, 1056,  770, 1556,
     1625, 1551, 1126, 1516, 1551, 1606, 1517, 1624, 1051,  767,
     1050, 1679, 1679, 1559, 1634, 1605, 1634, 1679, 1635, 1635,
     1635, 1635, 1635, 1635, 1635, 1635, 1635, 1679, 1679,  712,
     1679, 1020, 1019, 1016, 1015, 1014, 1011,  822, 1010, 1007,
     1609,  993,  992,  989,  988,  987,  984,  957, 1557, 1126,
     1526, 1557,  983, 1527, 1518, 1636, 1166, 1126, 1167, 1166,
      980, 1168,  943, 1637, 1637, 1637, 1637,  942,  941,  940,
      934, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637,

     1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637,
     1637, 1637, 1637, 1637, 1637, 1637, 1637, 1554, 1126, 1521,
     1554, 1608, 1522, 1166, 1126, 1167, 1166,  933, 1168, 1169,
     1638,  776, 1638,  579, 1639, 1639, 1639, 1639, 1639, 1639,
     1639, 1639, 1639,  931,  930,  929,  925,  919,  918,  759,
      910,  908,  907,  904,  904,  717,  893,  712, 1679, 1679,
     1679, 1679, 1679, 1679,  876,  876,  874,  874,  875,  873,
     1523, 1640, 1679,  628,  839,  833, 1169,  833,  790, 1641,
     1641, 1641, 1641,  790,  788,  788,  786, 1641, 1641, 1641,
     1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641,

     1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641,
     1641, 1641, 1641, 1557, 1126, 1526, 1557,  785, 1527,  784,
      783,  782,  781,  780,  771,  765, 1642,  761, 1642,  576,
     1643, 1643, 1643, 1643, 1643, 1643, 1643, 1643, 1643,  573,
      754,  750,  749,  748,  747,  746,  746,  739, 1679,  328,
      722,  721,  720,  516,  719,  714,  714, 1679, 1679, 1679,
      671, 1679, 1679,  485,  628, 1679, 1528, 1644,  623,  623,
      622,  622,  613,  612,  611, 1645, 1645, 1645, 1645,  610,
      609,  608,  607, 1645, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645,

     1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1551,
     1126, 1516, 1551,  603, 1517,  603,  601,  601,  400,  599,
      598,  597,  592,  391,  591,  590, 1635, 1635, 1635, 1635,
     1635, 1635, 1635, 1635, 1635,  580, 1554, 1126, 1521, 1554,
      384, 1522,  381,  574,  573,  373,  567,  566,  565,  564,
      563,  562,  556, 1639, 1639, 1639, 1639, 1639, 1639, 1639,
     1639, 1639, 1518, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1652, 1523,
     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,

     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,
     1653, 1653, 1653, 1653, 1653, 1653, 1557, 1126, 1526, 1557,
      556, 1527,  555,  555,  550,  549,  547,  546,  543,  158,
      328,  525,  525, 1643, 1643, 1643, 1643, 1643, 1643, 1643,
     1643, 1643,  520,  520,  518,  518,  519,  517,  515,  293,
      308,  510,  505,  504,  501,  492,  488,  485, 1679,  424,
      247,  422,  420,  418,  235,  233,  228,  406,  402, 1528,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1654, 1654,   38,   38,   38,   38,

       38,   38,   38,   38,   38,   38,   38,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   91,   91,   91,   91,   91,   91,   91,   91,
       91,   91,   91,   95,   95,   95,   95,   95,   95,   95,
       95,   95,   95,   95,  100,  100,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  103,  103,  103,  103,  103,

      103,  103,  103,  103,  103,  103,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  133,  133,  133,
      133,  168,  168,  404,  168,  168,  168,  168,  168,  168,
      168,  168,  178,  402,  226,  400,  178,  178,  178,  178,
      178,  178,  178,  183,  183,  398,  214,  183,  183,  183,
      183,  183,  183,  183,  189,  189,  208,  189,  189,  189,
      189,  189,  189,  189,  189,  191,  211,  210,  201,  191,
      191,  191,  191,  191,  191,  191,  193,  210,  367,  366,
      193,  193,  193,  193,  193,  193,  193,  195,  365,  364,
      363,  195,  195,  195,  195,  195,  195,  195,  212,  212,

      362,  212,  212,  212,  212,  212,  212,  212,  212,  221,
      221,  349,  221,  221,  221,  221,  221,  221,  221,  221,
      227,  227,  158,  227,  227,  227,  227,  227,  227,  227,
      227,  237,  237,  322,  237,  237,  237,  237,  237,  237,
      237,  237,  258,  258,  258,  258,  258,  258,  258,  258,
      258,  258,  258,  292,  292,  320,  292,  292,  292,  292,
      292,  292,  292,  292,  133,  133,  133,  133,  297,  297,
      317,  297,  297,  297,  297,  297,  297,  297,  297,  299,
      299,  316,  299,  299,  299,  299,  299,  299,  299,  299,
      307,  307,  295,  307,  307,  307,  307,  307,  307,  307,

      307,  312,  312,  294,  312,  312,  312,  312,  312,  312,
      312,  312,  318,  293,  318,  318,  319,  319,  321,  291,
      130,  321,  321,  178,  106,  232,  231,  178,  178,  178,
      178,  178,  178,  178,  183,  183,  226,  218,  183,  183,
      183,  183,  183,  183,  183,  189,  189,  217,  189,  189,
      189,  189,  189,  189,  189,  189,  191,  216,  211,  210,
      191,  191,  191,  191,  191,  191,  191,  193,  206,  194,
      192,  193,  193,  193,  193,  193,  193,  193,  195,  190,
      188,  187,  195,  195,  195,  195,  195,  195,  195,  371,
      371,  371,  371,  371,  371,  371,  371,  371,  371,  371,

      380,  380,  186,  380,  380,  380,  380,  380,  380,  380,
      380,  399,  399,  185,  399,  399,  399,  399,  399,  399,
      399,  399,  401,  401,  179,  401,  401,  401,  401,  401,
      401,  401,  401,  403,  403,  177,  403,  403,  403,  403,
      403,  403,  403,  403,  227,  227,  167,  227,  227,  227,
      227,  227,  227,  227,  227,  237,  237,  166,  237,  237,
      237,  237,  237,  237,  237,  237,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  292,  292,
      162,  292,  292,  292,  292,  292,  292,  292,  292,  307,

      307,  129,  307,  307,  307,  307,  307,  307,  307,  307,
      297,  297,  132,  297,  297,  297,  297,  297,  297,  297,
      297,  516,  516,  130,  516,  516,  516,  516,  516,  516,
      516,  516,  521,  521,  110,  521,  521,  521,  521,  521,
      521,  521,  521,  522,  522, 1679,  522,  522,  522,  522,
      522,  522,  522,  522,  523,  523,  523,  523,  523,  104,
      523,  523,  523,  523,  523,  524,  524,  104,  524,  524,
      524,  524,  524,  524,  524,  524,  527,  527,  528,  528,
      528,  528,   38,  528,  528,  528,  528,  528,  528,  529,
      529,  529,  529,  529,   38,  529,  529,  529,  529,  529,

      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  568,  568, 1679,  568,  568,  568,  568,  568,  568,
      568,  568,  371,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  575,  575, 1679,  575,  575,  575,  575,
      575,  575,  575,  575,  399,  399, 1679,  399,  399,  399,
      399,  399,  399,  399,  399,  600,  600, 1679,  600,  600,
      600,  600,  600,  600,  600,  600,  602,  602, 1679,  602,
      602,  602,  602,  602,  602,  602,  602,  606,  606, 1679,
      606,  606,  606,  606,  606,  606,  606,  606,  614,  614,
     1679,  614,  614,  614,  614,  614,  614,  614,  614,  237,

      237, 1679,  237,  237,  237,  237,  237,  237,  237,  237,
      627,  627, 1679,  627,  627,  627,  627,  627,  627,  627,
      627,  633,  633,  633,  633,  633,  633,  633,  633,  633,
      633,  633,  660,  660, 1679,  660,  660,  660,  660,  660,
      660,  660,  660,  662,  662, 1679,  662,  662,  662,  662,
      662,  662,  662,  662,  670,  670, 1679,  670,  670,  670,
      670,  670,  670,  670,  670,  484,  484, 1679,  484,  484,
      484,  484,  484,  484,  484,  484,  705,  705, 1679,  705,
      705,  705,  705,  705,  705,  705,  705,  717,  717, 1679,
      717,  717,  717,  717,  717,  717,  717,  717,  718,  718,

     1679,  718,  718,  718,  718,  718,  718,  718,  718,  523,
      523,  523,  523,  523,  523,  523,  523,  523,  523,  523,
      321,  321,  528,  528,  528,  528,  528,  528,  528,  528,
      528,  528,  528,  529,  529,  529,  529,  529,  529,  529,
      529,  529,  529,  529,  662,  662, 1679,  662,  662,  662,
      662,  662,  662,  662,  662,  568,  568, 1679,  568,  568,
      568,  568,  568,  568,  568,  568,  757,  757, 1679,  757,
      757,  757,  757,  757,  757,  757,  757,  787,  787, 1679,
      787,  787,  787,  787,  787,  787,  787,  787,  789,  789,
     1679,  789,  789,  789,  789,  789,  789,  789,  789,  832,

      832, 1679,  832,  832,  832,  832,  832,  832,  832,  832,
      614,  614, 1679,  614,  614,  614,  614,  614,  614,  614,
      614,  834,  834, 1679,  834,  834,  834,  834,  834,  834,
      834,  834,  835,  835, 1679,  835,  835,  835,  835,  835,
      835,  835,  835,  237,  237, 1679,  237,  237,  237,  237,
      237,  237,  237,  237,  836,  836, 1679,  836,  836,  836,
      836,  836,  836,  836,  836,  837,  837, 1679,  837,  837,
      837,  837,  837,  837,  837,  837,  838,  838, 1679,  838,
      838,  838,  838,  838,  838,  838,  838,  627,  627, 1679,
      627,  627,  627,  627,  627,  627,  627,  627,  633,  633,

     1679,  633,  633,  633,  633,  633,  633,  633,  633,  864,
      864, 1679,  864,  864,  864,  864,  864,  864,  864,  864,
      660,  660, 1679,  660,  660,  660,  660,  660,  660,  660,
      660,  872,  872, 1679,  872,  872,  872,  872,  872,  872,
      872,  872,  877,  877, 1679,  877,  877,  877,  877,  877,
      877,  877,  877,  878,  878,  878,  878,  878,  878,  878,
      878,  878,  878,  878,  882,  882,  882,  882,  882,  882,
      882,  882,  882,  882,  882,  883,  883,  883,  883,  883,
      883,  883,  883,  883,  883,  883,  884,  884, 1679,  884,
      884,  884,  884,  884,  884,  884,  884,  885,  885, 1679,

      885,  885,  885,  885,  885,  885,  885,  885,  886,  886,
     1679,  886,  886,  886,  886,  886,  886,  886,  886,  887,
      887, 1679,  887,  887,  887,  887,  887,  887,  887,  887,
      888,  888, 1679,  888,  888,  888,  888,  888,  888,  888,
      888,  889,  889, 1679,  889,  889,  889,  889,  889,  889,
      889,  889,  705,  705, 1679,  705,  705,  705,  705,  705,
      705,  705,  705,  891,  891, 1679,  891,  891,  891,  891,
      891,  891,  891,  891,  895, 1679,  895,  895,  895,  895,
      895,  895,  895,  895,  895,  872,  872, 1679,  872,  872,
      872,  872,  872,  872,  872,  872,  568,  568,  568,  568,

      568,  568,  568,  568,  568,  568,  568,  913,  913, 1679,
      913,  913,  913,  913,  913,  913,  913,  913,  944,  944,
     1679,  944,  944,  944,  944,  944,  944,  944,  944,  787,
      787, 1679,  787,  787,  787,  787,  787,  787,  787,  787,
      945,  945, 1679,  945,  945,  945,  945,  945,  945,  945,
      945,  789,  789, 1679,  789,  789,  789,  789,  789,  789,
      789,  789, 1021, 1021, 1679, 1021, 1021, 1021, 1021, 1021,
     1021, 1021, 1021,  832,  832, 1679,  832,  832,  832,  832,
      832,  832,  832,  832,  834,  834, 1679,  834,  834,  834,
      834,  834,  834,  834,  834,  835,  835, 1679,  835,  835,

      835,  835,  835,  835,  835,  835,  836,  836, 1679,  836,
      836,  836,  836,  836,  836,  836,  836,  837,  837, 1679,
      837,  837,  837,  837,  837,  837,  837,  837,  838,  838,
     1679,  838,  838,  838,  838,  838,  838,  838,  838, 1025,
     1025, 1679, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025,
     1026, 1026, 1679, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
     1026, 1027, 1027, 1679, 1027, 1027, 1027, 1027, 1027, 1027,
     1027, 1027, 1028, 1028, 1679, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1029, 1029, 1679, 1029, 1029, 1029, 1029,
     1029, 1029, 1029, 1029, 1030, 1030, 1679, 1030, 1030, 1030,

     1030, 1030, 1030, 1030, 1030,  864,  864, 1679,  864,  864,
      864,  864,  864,  864,  864,  864, 1032, 1032, 1679, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1034, 1034, 1679,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,  878,  878,
      878,  878,  878,  878,  878,  878,  878,  878,  878,  882,
      882,  882,  882,  882,  882,  882,  882,  882,  882,  882,
      883,  883,  883,  883,  883,  883,  883,  883,  883,  883,
      883,  884,  884, 1679,  884,  884,  884,  884,  884,  884,
      884,  884,  885,  885, 1679,  885,  885,  885,  885,  885,
      885,  885,  885,  886,  886, 1679,  886,  886,  886,  886,

      886,  886,  886,  886,  887,  887, 1679,  887,  887,  887,
      887,  887,  887,  887,  887,  888,  888, 1679,  888,  888,
      888,  888,  888,  888,  888,  888,  889,  889, 1679,  889,
      889,  889,  889,  889,  889,  889,  889,  891,  891, 1679,
      891,  891,  891,  891,  891,  891,  891,  891,  895, 1679,
      895,  895,  895,  895,  895,  895,  895,  895,  895, 1044,
     1044, 1679, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1075, 1075, 1679, 1075, 1075, 1075, 1075, 1075, 1075, 1075,
     1075, 1076, 1076, 1679, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1076, 1189, 1679, 1189, 1189, 1206, 1206, 1679, 1206,

     1206, 1206, 1206, 1206, 1206, 1206, 1206, 1025, 1025, 1679,
     1025, 1025, 1025, 1025, 1025, 1025, 1025, 1025, 1026, 1026,
     1679, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1027,
     1027, 1679, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027,
     1028, 1028, 1679, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1029, 1029, 1679, 1029, 1029, 1029, 1029, 1029, 1029,
     1029, 1029, 1030, 1030, 1679, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1032, 1032, 1679, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1209, 1209, 1209, 1209, 1209, 1209,
     1209, 1209, 1209, 1209, 1209, 1211, 1211, 1679, 1211, 1211,

     1211, 1211, 1211, 1211, 1211, 1211, 1238, 1238, 1679, 1238,
     1238, 1238, 1238, 1238, 1238, 1238, 1238, 1239, 1239, 1679,
     1239, 1239, 1239, 1239, 1239, 1239, 1239, 1239, 1392, 1392,
     1679, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1394,
     1394, 1679, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
     1408, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
     1411, 1411, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1414, 1414, 1414, 1419, 1419, 1679, 1419, 1419, 1419, 1419,
     1419, 1419, 1419, 1419, 1189, 1679, 1189, 1679, 1189, 1189,

     1426, 1679, 1426, 1679, 1426, 1426, 1453, 1453, 1679, 1453,
     1453, 1453, 1453, 1453, 1453, 1453, 1453, 1480, 1679, 1480,
     1480, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1519, 1519, 1519, 1519, 1519, 1519, 1519, 1519,
     1519, 1519, 1519, 1524, 1524, 1524, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1542, 1679, 1542, 1542,   37, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679
    } ;

static const flex_int32_t yy_chk[8302] =
    {   0,
        0,    0,    0,    3,    3,    4,    4,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    7,
        7,    7,    7,    8,    8,    8,    8,   15,    9,   10,
       25,   25,   25,   25,    7,   27,   27,   27,    8,   26,
       26,   26,   26,  436,   25,   25,    9,   10,   28,   28,
       28,   29,   30,   26,   26,   33,   33,  436,   29,   30,
       34,   34,   15, 1863,   48,   29,   30,   48,   15,  394,

       15,  394,    7,    9,   10,   60,    8,  241,   60,   40,
       40,   40,   40,   25,  241,   25,   67,   67,   40,   67,
       88,   88,   26,   15,   26,   40,  805,   68,  805,   15,
       68,   15,   29,   30,    9,   10,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       16,   43,   43,   43,   43, 1858,   46,   56,   44,   44,
       44,   44,   56,   97,  120,   43,   43,   44,   44,   87,
       87,   87,   87,   44,   44,   61,   61,   61,   61,   61,
       61,   61,  101,  101,  443,   16,   92,   92,   92,   92,
      386,   16,  938,   16,   46,  106,  106,  101,  443,   56,
      590,   97,  120,  106,   43,  105,  105,  105,  105,  113,
      106,   44,  113,  938,  131,  132,   16,  131,  132,  590,
      142,  386,   16,  142,   16,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   45,   45,   45,   45,  122,  141,  126,  170,  475,
      145,  170,   53,  145,  135,   53,   45,  135,  145,   54,
       54,   54,   54,  262,   84,  274,   53,   84,   54,   54,
       85,   85,   85,   85,  274,   54,  114,  114,   84,   84,
      247,  247,  283,  122,   98,  126,  171,   98,  141,  171,
      114,  301,  301,  283,   45,   52,   52,   52,   52,   52,
       52,   52,   52,   52,   52,   53,   52,  135,  388,   52,
       52,   52,   54,  144,   85,  262,  144,   84,  110,  110,

      110,  110,  144,   85,  475,   85,   98,  110,  114,  154,
      115,   52,  154,  165,  110,   98,  165,  115,  154,  388,
      172,  165,  115,  172,  115,  173,   52,   52,  173, 1856,
       52,   52,   52,   52,   52,   52,   52,   98,   52,  461,
      174,   52,   52,  174,   52,   52,   52,  441,   52,   52,
       52,   52,   52,   52,   52,  109,   52,   52,   52,  115,
      261,  676,  109,  111,  111,  111,  111,  109,  284,  284,
      284,  109,  109,  109,  261,  109,  458,  111,  111,  112,
      112,  112,  112,  115,  117,  117,  117,  117,  161,  175,
      109,  115,  175,  161,  112,  118,  118,  118,  118,  117,

      461,  156,  338,  109,  118,  118,  119,  119,  119,  119,
      118,  118,  261,  338,  155,  156,  111,  155,  583,  176,
      183,  119,  176,  183,  125,  125,  125,  125,  155,  441,
      161,  454,  112,  125,  125,  184,  458,  117,  184,  125,
      125,  676,  157,  157,  157,  157,  313,  313,  118,  137,
      137,  137,  137,  137,  137,  137,  137,  583,  140,  119,
      123,  123,  140,  123,  140,  140,  196,  155,  210,  196,
      140,  210,  328,  328,  156,  140,  123,  125,  140,  532,
      196,  196,  156,  168,  168,  168,  168,  123,  197,  197,
      197,  197, 1256,  123,  123,  157,  263,  123,  440,  123,

      454,  123,  440,  123,  123,  123, 1846,  123,  169,  123,
      263,  169,  534,  123,  207,  207,  207,  207,  123,  196,
      123,  210,  123,  343,  343,  123,  169,  169,  169,  169,
      123,  198,  198,  198,  198,  123,  124,  124,  124,  124,
      124,  124,  124,  124,  124,  124,  198,  124,  263, 1761,
      124,  124,  124,  153,  532,  153,  630,  153,  153,  153,
      153,  153,  153,  153,  153,  153,  630,  158,  158,  158,
      158,  244,  124,  535,  244, 1256,  158,  158,  208,  208,
      208,  208,  238,  158,  534,  238,  200,  124,  124,  200,
      674,  124,  124,  124,  124,  124,  124,  124,  674,  124,

      447,  200,  124,  124,  481,  124,  124,  124,  481,  124,
      124,  124,  124,  124,  124,  124,  238,  124,  124,  124,
      158,  160,  160, 1287,  160,  238,  160,  162,  162,  162,
      162,  203,  346,  346,  160,  160,  162,  162,  163,  200,
      447,  160,  163,  162,  163,  163,  201,  201,  201,  201,
      163,  203,  535,  224,  266,  163,  279,  266,  163,  279,
      228,  228,  203,  206,  206,  206,  206,  395,  395,  449,
      160,  213,  213,  213,  213,  228,  214,  214,  214,  214,
      162,  224,  203,  216,  216,  216,  216,  585,  267,  267,
      201,  267,  224,  239, 1737,  230,  239,  230,  224,  201,

      457,  201,  214,  214,  231,  231,  230,  206,  230,  449,
      230,  214,  224,  425,  425,  214,  206,  230,  206,  231,
      239,  214,  688,  224,  235,  235,  585,  242,  296,  224,
      688,  296,  235,  242,  246, 1287,  239,  349,  242,  235,
      349,  214,  239,  230,  242,  246,  249,  249,  249,  249,
      242,  246,  251,  429,  429,  251,  252,  252,  252,  252,
      251,  512,  512, 1728,  242,  246,  253,  350,  684,  253,
      350,  252,  684,  457,  253,  242,  246,  254,  254,  254,
      254,  242,  246,  255,  255,  255,  255,  256,  256,  256,
      256,  537,  254,  538,  257,  584,  275,  351,  255,  275,

      351,  257,  256,  214,  214,  214,  257,  270,  257,  252,
      270,  214,  272,  214,  214,  272,  259,  259,  259,  259,
      260,  260,  260,  260,  310,  275,  584,  310,  736,  289,
      254,  259,  289,  310,  375,  260,  255,  275,  450,  272,
      256,  270,  276,  257,  289,  276,  435,  286, 1327,  276,
      270,  277,  677,  272,  375,  272,  591,  277,  286,  276,
      435,  272,  277,  290,  286,  375,  290,  257,  277,  259,
      537,  290,  538,  260,  277,  257,  264,  264,  286,  264,
      352,  353,  289,  352,  353,  375,  286,  291,  277,  286,
      291,  325,  264,  342,  325,  286,  342,  450,  435,  277,

      325,  342,  291,  264,  354,  277,  450,  354,  736,  264,
      264,  330,  330,  264,  330,  264,  677,  264,  591,  264,
      264,  264, 1279,  264,  355,  264,  825,  355,  825,  264,
      327,  327,  327,  327,  264,  724,  264, 1676,  264,  356,
      291,  264,  356, 1249,  357,  358,  264,  357,  358,  552,
      552,  264,  265,  265,  265,  265,  265,  265,  265,  265,
      265,  265,  359,  265,  330,  359,  265,  265,  265,  323,
      323,  323,  323,  323,  323,  323,  323,  323,  360,  361,
     1327,  360,  361,  327,  368,  368,  368,  368,  265,  369,
      369,  369,  369,  587,  373,  373,  373,  373,  379,  379,

      379,  379,  415,  265,  265,  415,  841,  265,  265,  265,
      265,  265,  265,  265,  724,  265, 1672,  335,  265,  265,
      335,  265,  265,  265,  459,  265,  265,  265,  265,  265,
      265,  265,  587,  265,  265,  265,  332,  332,  373,  332,
      370,  416,  372,  370,  416,  372, 1279,  373,  780,  373,
      417,  335,  332,  417,  781,  370,  418,  372,  419,  418,
      335,  419,  332,  332, 1249,  332,  588,  332,  420,  332,
      332,  420,  780,  332,  781,  332,  332,  332,  737,  332,
      332,  332,  332,  332,  421,  332,  841,  421,  459,  332,
     1671,  341,  335,  370,  332,  372,  332,  335,  332,  459,

      422,  332,  341,  422,  423,  588,  332,  423,  341,  592,
      592,  332,  333,  333,  333,  333,  333,  333,  333,  333,
      333,  333,  341,  333,  664,  664,  333,  333,  333,  424,
      341,  428,  424,  341,  428,  405,  405,  405,  405,  341,
      405,  438,  737,  438,  442,  442,  487,  442,  333,  487,
      438,  444,  444,  455,  444,  438, 1668,  438,  878,  433,
      433,  433,  433,  333,  333,  675,  878,  333,  333,  333,
      333,  333,  333,  333,  433,  333,  882,  460,  333,  333,
      882,  333,  333,  333,  761,  333,  333,  333,  333,  333,
      333,  333,  438,  333,  333,  333,  381,  381,  381,  381,

     1253,  383,  383,  383,  383, 1157,  434,  434,  434,  434,
      455,  488,  433,  455,  488,  761,  438,  384,  384,  384,
      384,  434,  381,  381,  438, 1157,  389,  383,  383,  451,
      451,  381,  451,  675,  675,  381,  383,  460,  460,  460,
      383,  381,  486,  384,  384,  486,  383,  486,  437,  437,
      437,  437,  384,  389,  474,  844,  384,  389,  451,  434,
      452,  381,  384,  437,  732,  732,  383,  389,  446,  446,
      451,  446,  448,  448,  762,  448,  473,  473,  489,  473,
      389,  489,  384,  883,  389,  473,  452,  490,  389,  452,
      490,  883,  735,  452,  464,  464,  774,  464,  389,  448,

      453,  437,  446,  452,  491,  762,  983,  491,  462,  483,
      483,  446,  483,  448,  474,  448,  492,  474,  483,  492,
     1253,  448,  474,  381,  381,  381,  453,  774,  383,  383,
      383,  381,  453,  381,  381,  844,  383,  453,  383,  383,
      462,  809,  809,  453,  384,  384,  384,  464,  764,  453,
     1667,  462,  384,  389,  384,  384,  493,  462,  469,  493,
      735,  735,  469,  453,  469,  469,  494,  764,  983,  494,
      469,  462,  466,  495,  453,  469,  495, 1664,  469,  462,
      453,  456,  462,  471,  471, 1197,  471,  842,  462,  466,
      466,  466,  466,  466,  466,  466,  466,  496,  471,  497,

      496,  498,  497,  775,  498, 1197,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  499,  536,  775,  499,  471,  478,  500,  501,
      502,  500,  501,  502,  503,  504,  478,  503,  504,  507,
      508,  842,  507,  508,  478,  478,  478,  478,  509,  829,
      829,  509,  478,  478,  478,  478,  478,  478,  478,  478,
      478,  478,  478,  478,  478,  478,  478,  478,  478,  478,
      478,  478,  478,  478,  478,  478,  478,  478,  479,  511,
      511,  511,  511,  515,  518,  543,  515,  518,  543,  545,

      546,  536,  545,  546,  547,  548,  549,  547,  548,  549,
      793,  542,  536,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  550,
      551,  793,  550,  551,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      479,  479,  479,  479,  479,  479,  479,  479,  479,  479,
      480,  542,  557,  558,  542,  557,  558,  559,  560,  542,
      559,  560,  561,  794, 1662,  561,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,

      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  566,  617,  794,  566,  617,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
      480,  480,  480,  482,  533,  533,  573,  533,  795,  573,
      505,  539,  845,  505,  531,  482,  531,  482,  625,  482,
      482,  482,  482,  482,  482,  482,  482,  482,  505,  540,
      531,  565, 1010,  540,  565,  540,  540,  569,  533,  795,
      569,  540,  581,  539, 1251,  621,  540,  533,  621,  540,
      565,  879,  569, 1114,  539,  570,  570,  570,  570,  573,

      539,  576,  576,  576,  576,  581,  578,  578,  578,  578,
      570,  796,  626,  581,  539,  505,  845,  622,  625,  533,
      622,  625,  539, 1251,  533,  539,  625,  576,  576,  531,
      569,  539,  578,  578, 1010,  589,  576,  531,  797,  589,
      576,  578,  796,  765,  879,  578,  576,  579,  579,  579,
      579,  578,  589,  624,  624, 1114,  624,  765,  589,  631,
      631,  799,  631, 1257,  632,  632,  576,  632,  624,  797,
      693,  578,  626,  693,  765,  626,  634,  634,  581,  634,
      626,  634,  635,  635, 1321,  635,  636,  636,  765,  636,
      637,  637,  799,  637,  638,  638,  801,  638,  639,  639,

      813,  639,  640,  640,  821,  640,  624,  641,  641,  801,
      641,  642,  642,  980,  642,  643,  643,  821,  643,  644,
      644, 1252,  644,  645,  645,  960,  645,  960,  576,  576,
      576,  813,  980,  578,  578,  578,  576,  694,  576,  576,
      694,  578,  987,  578,  578,  604,  604,  604,  604,  987,
      604,  646,  646, 1156,  646,  647,  647, 1196,  647,  648,
      648,  814,  648,  649,  649,  815,  649,  650,  650, 1257,
      650,  604,  604,  651,  651,  653,  651, 1156,  653,  604,
      604, 1196,  695,  604,  604,  695,  604, 1658,  652,  652,
      604,  652,  814,  653,  655,  655,  815,  655,  604,  656,

      656, 1321,  656,  657,  657,  696,  657, 1091,  696, 1091,
      604,  659,  659,  659,  659,  672,  672, 1306,  672,  673,
      673, 1306,  673,  687,  687,  685,  687,  697,  673, 1252,
      697,  700,  687,  701,  700,  702,  701, 1657,  702,  816,
      653,  685,  685,  685,  685,  685,  685,  685,  685,  685,
      703,  704,  706,  703,  704,  706,  707,  709,  710,  707,
      709,  710,  711,  817, 1656,  711,  712,  712,  712,  712,
      816,  819,  604,  604,  604, 1326,  604,  604,  604, 1007,
      604, 1325,  604,  604,  605,  605,  605,  605,  715,  605,
      716,  715,  720,  716,  817,  720,  723,  723, 1007,  723,

      725,  725,  819,  725,  726,  726,  738,  726,  840,  738,
      605,  605,  727,  727,  739,  727,  843,  739,  605,  605,
      956,  740,  605,  605,  740,  605, 1259,  728,  728,  605,
      728,  729,  729,  956,  729,  730,  730,  605,  730,  731,
      731,  741,  731,  742,  741,  743,  742,  744,  743,  605,
      744,  745,  749,  751,  745,  749,  751,  752,  753,  754,
      752,  753,  754,  755,  755,  755,  755,  756,  756,  756,
      756,  758,  758,  758,  758,  759,  840,  840,  759,  768,
      768,  768,  768,  839,  843,  843,  839,  846,  846,  905,
      846,  782,  847,  847,  782,  847,  852,  852, 1063,  852,

      853,  853, 1282,  853,  854,  854,  861,  854, 1326,  861,
     1325,  605,  605,  605, 1063,  605,  605,  605, 1633,  605,
     1063,  605,  605,  679,  855,  855, 1632,  855,  856,  856,
     1259,  856,  859,  859, 1328,  859,  860,  860, 1328,  860,
      862,  862,  905,  862,  863,  863,  915,  863,  679,  679,
      679,  679,  679,  679,  679,  679,  679,  679,  679,  679,
      679,  679,  679,  679,  679,  679,  679,  679,  679,  679,
      679,  679,  679,  679,  682,  865,  866, 1087,  865,  866,
      868,  868, 1337,  868,  869,  869, 1337,  869,  870,  870,
     1087,  870,  874,  874,  890,  874, 1280,  890,  915,  682,

      682,  682,  682,  682,  682,  682,  682,  682,  682,  682,
      682,  682,  682,  682,  682,  682,  682,  682,  682,  682,
      682,  682,  682,  682,  682,  767,  782,  782, 1282,  915,
      682,  682,  682,  682,  682,  682,  682,  682,  682,  682,
      682,  682,  682,  682,  682,  682,  682,  682,  682,  682,
      682,  682,  682,  682,  682,  682,  767,  770,  770,  770,
      770,  770, 1129,  893,  892,  767,  893,  892,  894,  896,
      896,  894,  896,  897,  897, 1129,  897,  898,  898,  917,
      898,  899,  899,  906,  899,  770,  906,  767,  770,  900,
      900,  927,  900,  916,  792,  792,  767,  770,  901,  901,

     1631,  901,  792,  792, 1630,  908,  792,  792,  908,  792,
      917,  902,  902,  792,  902,  909,  770,  892,  909,  770,
     1280,  792,  903,  903,  910,  903,  929,  910,  770,  791,
      791,  791,  791,  792,  791,  927,  911,  912,  798,  911,
      912,  914,  798, 1628,  914,  916,  798,  921,  921,  921,
      921,  921,  798,  935,  935,  791,  791,  929,  798,  932,
      928,  937,  937,  791,  791,  798,  927,  791,  791,  798,
      791,  939,  939,  798,  791, 1283,  916,  798,  964,  964,
      984,  984,  791,  798,  922,  922,  922,  922,  922,  798,
      932, 1014,  948, 1627,  791,  792,  792,  792, 1014,  792,

      792,  792, 1023,  792,  928,  792,  792,  812,  812,  923,
      923,  923,  923,  923, 1255,  812,  812,  949, 1284,  812,
      812,  950,  812,  948,  947,  947,  812,  924,  924,  924,
      924,  924,  947,  947,  812,  928,  947,  947,  798,  947,
      951, 1355,  952,  947,  954,  818,  812,  968,  949,  818,
      969,  947,  950,  818,  970, 1023,  791,  791,  791,  818,
      791,  791,  791,  947,  791,  818,  791,  791,  971,  973,
      974,  951,  818,  952,  975,  954,  818,  970,  968, 1283,
      818,  969, 1011, 1011,  818,  970,  967,  967,  967,  967,
      818,  967,  976,  979,  978, 1118,  818,  995,  978,  971,

      973,  974, 1118,  996, 1284,  975,  998, 1000,  812,  812,
      812,  978,  812,  812,  812, 1255,  812,  978,  812,  812,
     1067, 1067, 1316,  976,  979,  947,  947,  947,  995,  947,
      947,  947, 1614,  947,  996,  947,  947,  998, 1000,  967,
     1022, 1022, 1315, 1022, 1500,  818,  880,  982, 1355,  982,
      970,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      994,  994,  994,  994, 1500,  994, 1348, 1001, 1002, 1003,
     1006,  880,  880,  880,  880,  880,  880,  880,  880,  880,
      880,  880,  880,  880,  880,  880,  880,  880,  880,  880,
      880,  880,  880,  880,  880,  880,  880,  881, 1001, 1002,

     1003, 1006, 1024, 1024, 1031, 1024, 1316, 1031, 1033, 1033,
     1611, 1033, 1600,  994, 1036, 1036, 1595, 1036, 1038, 1038,
     1594, 1038,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881, 1040, 1040,
     1315, 1040, 1348,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  946,
      946,  946,  946, 1042,  946, 1111, 1042, 1043,  953, 1353,
     1043,  972,  953, 1095, 1095, 1050,  953, 1061,  997, 1079,

     1115, 1115,  953,  972, 1111,  946,  946, 1046,  953, 1047,
     1080, 1081,  972,  946,  946,  953,  972,  946,  946,  953,
      946,  997,  972,  953,  946,  999, 1050,  953, 1061,  997,
     1079, 1005,  946,  953,  972, 1005, 1051,  999, 1046,  953,
     1047, 1080, 1081,  972,  946, 1051,  999,  972, 1005, 1082,
      999, 1058, 1592, 1009, 1005, 1009,  999, 1009, 1009, 1009,
     1009, 1009, 1009, 1009, 1009, 1009, 1169, 1051,  999, 1046,
     1059, 1047, 1049, 1049, 1049, 1049, 1051,  999, 1083, 1169,
     1082,  999, 1058, 1062, 1062, 1062, 1062, 1320,  953, 1589,
     1085, 1099, 1100, 1102,  997, 1575, 1134, 1065, 1065, 1104,

     1105, 1059, 1101, 1349, 1286, 1353,  946,  946,  946, 1083,
      946,  946,  946, 1058,  946, 1134,  946,  946,  981, 1065,
     1065, 1085, 1099, 1100, 1102, 1101,  981,  981,  981,  981,
     1104, 1105, 1059, 1101,  981,  981,  981,  981,  981,  981,
      981,  981,  981,  981,  981,  981,  981,  981,  981,  981,
      981,  981,  981,  981,  981,  981,  981,  981,  981,  981,
     1056, 1056, 1056, 1056, 1098, 1098, 1098, 1098, 1320, 1098,
     1106, 1103, 1565, 1107, 1110, 1130, 1078, 1078, 1126, 1126,
     1126, 1126, 1132, 1103, 1078, 1078, 1286, 1056, 1078, 1078,
     1056, 1078, 1103, 1135, 1126, 1078, 1103, 1285, 1101, 1056,

     1174, 1106, 1103, 1078, 1107, 1110, 1130, 1136, 1084, 1138,
     1141, 1349, 1084, 1132, 1103, 1078, 1084, 1098, 1056, 1174,
     1562, 1056, 1084, 1103, 1135, 1109, 1560, 1103, 1084, 1109,
     1056, 1077, 1077, 1077, 1077, 1084, 1077, 1143, 1136, 1084,
     1138, 1141, 1109, 1084, 1145, 1380, 1380, 1084, 1109, 1125,
     1125, 1125, 1125, 1084, 1125, 1146, 1550, 1077, 1077, 1084,
     1127, 1127, 1127, 1127, 1210, 1077, 1077, 1210, 1143, 1077,
     1077, 1393, 1077, 1296, 1393, 1145, 1077, 1078, 1078, 1078,
     1139, 1078, 1078, 1078, 1077, 1078, 1146, 1078, 1078, 1128,
     1128, 1128, 1128, 1113, 1139, 1113, 1077, 1113, 1113, 1113,

     1113, 1113, 1113, 1113, 1113, 1113, 1137, 1147, 1084, 1170,
     1137, 1139, 1131, 1131, 1131, 1131, 1285, 1131, 1172, 1137,
     1352, 1140, 1140, 1140, 1140, 1139, 1140, 1150, 1150, 1150,
     1150, 1150, 1150, 1150, 1150, 1150, 1162, 1137, 1147, 1162,
     1170, 1137, 1166, 1166, 1166, 1166, 1175, 1166, 1317, 1172,
     1137, 1167, 1167, 1167, 1167, 1549, 1271, 1296, 1077, 1077,
     1077, 1271, 1077, 1077, 1077, 1131, 1077, 1548, 1077, 1077,
     1112, 1250, 1207, 1207, 1140, 1207, 1296, 1175, 1112, 1112,
     1112, 1112, 1168, 1168, 1168, 1168, 1112, 1112, 1112, 1112,
     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,

     1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
     1112, 1112, 1142, 1142, 1142, 1142, 1275, 1142, 1149, 1149,
     1176, 1275, 1178, 1354, 1179, 1181, 1149, 1149, 1250, 1202,
     1149, 1149, 1202, 1149, 1314, 1151, 1151, 1149, 1179, 1142,
     1278, 1250, 1142, 1151, 1151, 1149, 1352, 1151, 1151, 1317,
     1151, 1176, 1142, 1178, 1151, 1179, 1181, 1149, 1171, 1171,
     1171, 1171, 1151, 1171, 1346, 1142, 1322, 1314, 1260, 1179,
     1142, 1162, 1162, 1142, 1151, 1180, 1180, 1180, 1180, 1183,
     1180, 1185, 1186, 1142, 1148, 1148, 1148, 1148, 1148, 1148,
     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,

     1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148, 1148,
     1183, 1171, 1185, 1186, 1187, 1323, 1214, 1212, 1177, 1149,
     1149, 1149, 1177, 1149, 1149, 1149, 1358, 1149, 1180, 1149,
     1149, 1177, 1208, 1208, 1346, 1208, 1151, 1151, 1151, 1215,
     1151, 1151, 1151, 1547, 1151, 1187, 1151, 1151, 1212, 1177,
     1354, 1214, 1217, 1177, 1182, 1182, 1182, 1182, 1258, 1182,
     1189, 1189, 1177, 1260, 1202, 1202, 1501, 1322, 1189, 1189,
     1278, 1278, 1189, 1189, 1215, 1189, 1351, 1209, 1209, 1189,
     1209, 1182, 1214, 1217, 1182, 1242, 1501, 1189, 1218, 1218,
     1218, 1218, 1281, 1387, 1182, 1219, 1219, 1219, 1219, 1189,

     1220, 1220, 1220, 1220, 1221, 1215, 1295, 1182, 1226, 1242,
     1254, 1295, 1182, 1360, 1387, 1182, 1190, 1190, 1190, 1190,
     1190, 1190, 1190, 1190, 1190, 1182, 1546, 1358, 1358, 1191,
     1191, 1227, 1227, 1227, 1227, 1221, 1359, 1191, 1191, 1226,
     1242, 1191, 1191, 1323, 1191, 1243, 1258, 1258, 1191, 1223,
     1223, 1223, 1223, 1223, 1545, 1291, 1191, 1228, 1228, 1228,
     1228, 1189, 1189, 1189, 1244, 1189, 1189, 1189, 1191, 1189,
     1243, 1189, 1189, 1224, 1224, 1224, 1224, 1224, 1232, 1232,
     1232, 1232, 1233, 1233, 1233, 1233, 1234, 1234, 1234, 1234,
     1236, 1236, 1236, 1236, 1245, 1246, 1248, 1244, 1263, 1265,

     1351, 1243, 1277, 1254, 1347, 1254, 1261, 1261, 1261, 1261,
     1333, 1261, 1291, 1267, 1262, 1333, 1363, 1248, 1365, 1281,
     1246, 1363, 1538, 1263, 1274, 1291, 1281, 1245, 1244, 1360,
     1191, 1191, 1191, 1265, 1191, 1191, 1191, 1268, 1191, 1319,
     1191, 1191, 1240, 1240, 1240, 1240, 1273, 1240, 1248, 1365,
     1292, 1246, 1272, 1359, 1263, 1267, 1502, 1264, 1245, 1261,
     1262, 1347, 1277, 1241, 1265, 1536, 1318, 1361, 1240, 1240,
     1268, 1386, 1386, 1247, 1534, 1292, 1240, 1240, 1502, 1269,
     1240, 1240, 1264, 1240, 1241, 1241, 1267, 1240, 1273, 1266,
     1531, 1262, 1241, 1241, 1247, 1240, 1241, 1241, 1247, 1241,

     1294, 1268, 1247, 1241, 1270, 1264, 1292, 1240, 1247, 1274,
     1266, 1241, 1269, 1264, 1247, 1288, 1288, 1288, 1288, 1273,
     1288, 1247, 1266, 1241, 1277, 1247, 1305, 1319, 1274, 1247,
     1406, 1266, 1272, 1247, 1294, 1266, 1272, 1270, 1300, 1247,
     1529, 1266, 1512, 1269, 1511, 1247, 1510, 1319, 1504, 1272,
     1498, 1305, 1366, 1266, 1406, 1272, 1289, 1289, 1289, 1289,
     1318, 1289, 1266, 1297, 1298, 1294, 1266, 1361, 1270, 1240,
     1240, 1240, 1300, 1240, 1240, 1240, 1495, 1240, 1264, 1240,
     1240, 1307, 1305, 1366, 1318, 1241, 1241, 1241, 1492, 1241,
     1241, 1241, 1276, 1241, 1247, 1241, 1241, 1298, 1297, 1488,

     1276, 1301, 1276, 1300, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1290, 1290, 1290, 1290, 1299, 1290, 1293,
     1293, 1293, 1293, 1303, 1293, 1308, 1309, 1307, 1298, 1297,
     1301, 1302, 1302, 1302, 1302, 1336, 1302, 1329, 1299, 1335,
     1329, 1342, 1299, 1487, 1301, 1324, 1308, 1356, 1324, 1486,
     1324, 1299, 1303, 1329, 1332, 1332, 1332, 1332, 1307, 1332,
     1309, 1301, 1304, 1304, 1304, 1304, 1342, 1304, 1335, 1299,
     1336, 1338, 1293, 1299, 1311, 1301, 1509, 1308, 1485, 1340,
     1343, 1484, 1299, 1303, 1302, 1350, 1331, 1331, 1339, 1304,
     1331, 1309, 1304, 1483, 1331, 1311, 1311, 1342, 1331, 1335,

     1509, 1336, 1304, 1311, 1311, 1343, 1357, 1311, 1311, 1339,
     1311, 1368, 1312, 1338, 1311, 1304, 1313, 1340, 1474, 1344,
     1304, 1572, 1311, 1304, 1312, 1312, 1312, 1312, 1312, 1312,
     1312, 1312, 1312, 1304, 1311, 1473, 1343, 1313, 1313, 1470,
     1339, 1572, 1368, 1344, 1338, 1313, 1313, 1469, 1340, 1313,
     1313, 1567, 1313, 1334, 1465, 1369, 1313, 1362, 1362, 1362,
     1362, 1334, 1370, 1334, 1313, 1334, 1334, 1334, 1334, 1334,
     1334, 1334, 1334, 1334, 1344, 1567, 1313, 1356, 1356, 1573,
     1324, 1324, 1341, 1341, 1341, 1341, 1369, 1341, 1388, 1388,
     1357, 1568, 1372, 1370, 1446, 1446, 1311, 1311, 1311, 1573,

     1311, 1311, 1311, 1345, 1311, 1373, 1311, 1311, 1345, 1350,
     1350, 1357, 1397, 1464, 1374, 1568, 1345, 1345, 1345, 1345,
     1364, 1341, 1364, 1372, 1364, 1364, 1364, 1364, 1364, 1364,
     1364, 1364, 1364, 1395, 1398, 1341, 1373, 1400, 1313, 1313,
     1313, 1397, 1313, 1313, 1313, 1374, 1313, 1401, 1313, 1313,
     1404, 1649, 1341, 1371, 1371, 1371, 1371, 1405, 1371, 1659,
     1405, 1463, 1424, 1398, 1395, 1459, 1456, 1452, 1400, 1574,
     1451, 1649, 1397, 1407, 1407, 1407, 1407, 1405, 1401, 1659,
     1450, 1404, 1405, 1408, 1408, 1408, 1408, 1409, 1409, 1409,
     1409, 1574, 1371, 1424, 1398, 1410, 1410, 1410, 1410, 1411,

     1411, 1411, 1411, 1429, 1431, 1449, 1371, 1412, 1412, 1412,
     1412, 1413, 1413, 1413, 1413, 1414, 1414, 1414, 1414, 1415,
     1415, 1415, 1415, 1371, 1416, 1416, 1416, 1416, 1422, 1422,
     1423, 1423, 1423, 1423, 1429, 1431, 1422, 1422, 1448, 1447,
     1422, 1422, 1445, 1422, 1616, 1444, 1443, 1422, 1426, 1426,
     1426, 1426, 1432, 1426, 1433, 1422, 1427, 1427, 1427, 1427,
     1427, 1427, 1427, 1427, 1427, 1434, 1616, 1422, 1428, 1428,
     1428, 1428, 1442, 1428, 1430, 1430, 1430, 1430, 1455, 1430,
     1457, 1458, 1435, 1432, 1435, 1433, 1435, 1435, 1435, 1435,
     1435, 1435, 1435, 1435, 1435, 1438, 1434, 1437, 1437, 1437,

     1437, 1426, 1437, 1440, 1440, 1460, 1441, 1475, 1496, 1455,
     1648, 1438, 1439, 1436, 1457, 1458, 1476, 1438, 1494, 1418,
     1417, 1428, 1403, 1402, 1399, 1440, 1440, 1430, 1497, 1422,
     1422, 1422, 1648, 1422, 1422, 1422, 1460, 1422, 1475, 1422,
     1422, 1461, 1461, 1461, 1461, 1457, 1458, 1476, 1496, 1494,
     1437, 1462, 1462, 1462, 1462, 1466, 1466, 1466, 1466, 1467,
     1467, 1467, 1467, 1468, 1468, 1468, 1468, 1472, 1497, 1499,
     1396, 1617, 1472, 1481, 1481, 1481, 1481, 1661, 1481, 1496,
     1472, 1472, 1472, 1472, 1477, 1477, 1477, 1477, 1477, 1477,
     1477, 1477, 1477, 1478, 1478, 1617, 1505, 1661, 1506, 1497,

     1499, 1478, 1478, 1650, 1392, 1478, 1478, 1532, 1478, 1480,
     1480, 1391, 1478, 1618, 1530, 1535, 1543, 1480, 1480, 1619,
     1390, 1480, 1480, 1389, 1480, 1650, 1481, 1505, 1480, 1506,
     1385, 1544, 1478, 1482, 1482, 1482, 1482, 1618, 1482, 1489,
     1489, 1489, 1489, 1619, 1489, 1530, 1535, 1543, 1480, 1660,
     1490, 1490, 1490, 1490, 1532, 1490, 1491, 1491, 1491, 1491,
     1384, 1491, 1544, 1651, 1493, 1493, 1493, 1493, 1503, 1493,
     1503, 1660, 1503, 1503, 1503, 1503, 1503, 1503, 1503, 1503,
     1503, 1508, 1561, 1665, 1508, 1532, 1482, 1651, 1513, 1513,
     1513, 1513, 1489, 1513, 1478, 1478, 1478, 1383, 1478, 1478,

     1478, 1508, 1478, 1490, 1478, 1478, 1508, 1665, 1382, 1491,
     1480, 1480, 1480, 1561, 1480, 1480, 1480, 1493, 1480, 1507,
     1480, 1480, 1537, 1537, 1537, 1537, 1381, 1507, 1507, 1507,
     1507, 1514, 1514, 1514, 1514, 1670, 1514, 1515, 1515, 1515,
     1515, 1513, 1515, 1516, 1516, 1516, 1516, 1379, 1516, 1517,
     1517, 1517, 1517, 1378, 1517, 1518, 1518, 1518, 1518, 1670,
     1518, 1519, 1519, 1519, 1519, 1377, 1519, 1520, 1520, 1520,
     1520, 1533, 1520, 1521, 1521, 1521, 1521, 1376, 1521, 1563,
     1522, 1522, 1522, 1522, 1514, 1522, 1523, 1523, 1523, 1523,
     1515, 1523, 1524, 1524, 1524, 1524, 1516, 1524, 1525, 1525,

     1525, 1525, 1517, 1525, 1526, 1526, 1526, 1526, 1518, 1526,
     1527, 1527, 1527, 1527, 1519, 1527, 1566, 1518, 1533, 1563,
     1520, 1570, 1528, 1528, 1528, 1528, 1521, 1528, 1571, 1588,
     1518, 1593, 1375, 1522, 1564, 1540, 1540, 1540, 1540, 1523,
     1540, 1542, 1542, 1542, 1542, 1524, 1542, 1566, 1523, 1533,
     1563, 1525, 1570, 1551, 1551, 1551, 1551, 1526, 1551, 1571,
     1588, 1523, 1593, 1527, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1596, 1564, 1528, 1554, 1554, 1554, 1554,
     1569, 1554, 1597, 1610, 1528, 1601, 1367, 1330, 1569, 1569,
     1569, 1569, 1604, 1601, 1601, 1601, 1601, 1528, 1310, 1615,

     1604, 1604, 1604, 1604, 1596, 1564, 1551, 1552, 1552, 1552,
     1552, 1666, 1552, 1597, 1610, 1239, 1238, 1552, 1557, 1557,
     1557, 1557, 1237, 1557, 1235, 1552, 1552, 1552, 1552, 1554,
     1615, 1666, 1590, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552,
     1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1607,
     1552, 1553, 1553, 1553, 1553, 1590, 1553, 1607, 1607, 1607,
     1607, 1557, 1626, 1669, 1553, 1673, 1553, 1674, 1553, 1553,
     1553, 1553, 1553, 1553, 1553, 1553, 1553, 1556, 1556, 1556,
     1556, 1629, 1556, 1231, 1230, 1669, 1590, 1673, 1229, 1674,

     1556, 1677, 1556, 1626, 1556, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1225, 1553, 1555, 1555, 1555, 1555, 1222,
     1555, 1216, 1629, 1677, 1213, 1555, 1205, 1577, 1577, 1577,
     1577, 1204, 1577, 1555, 1555, 1555, 1555, 1203, 1201, 1200,
     1556, 1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555,
     1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555, 1555,
     1555, 1555, 1555, 1555, 1555, 1555, 1555, 1199, 1555, 1558,
     1558, 1558, 1558, 1198, 1558, 1646, 1646, 1646, 1646, 1558,
     1577, 1579, 1579, 1579, 1579, 1195, 1579, 1558, 1558, 1558,
     1558, 1194, 1193, 1192, 1591, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1184, 1558, 1559, 1559, 1559, 1559, 1591, 1559, 1173,
     1581, 1581, 1581, 1581, 1579, 1581, 1559, 1165, 1559, 1164,
     1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559, 1612,
     1612, 1612, 1612, 1612, 1647, 1647, 1647, 1647, 1591, 1613,
     1613, 1613, 1613, 1613, 1655, 1655, 1655, 1655, 1163, 1161,
     1583, 1583, 1583, 1583, 1160, 1583, 1559, 1576, 1159, 1585,
     1585, 1585, 1585, 1581, 1585, 1576, 1576, 1576, 1576, 1675,
     1675, 1675, 1675, 1576, 1576, 1576, 1576, 1576, 1576, 1576,

     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 1578,
     1578, 1578, 1578, 1583, 1578, 1587, 1587, 1587, 1587, 1158,
     1587, 1155, 1585, 1154, 1153, 1152, 1578, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1652, 1144, 1133, 1124, 1653,
     1123, 1122, 1121, 1652, 1652, 1652, 1652, 1653, 1653, 1653,
     1653, 1120, 1119, 1117, 1116, 1108, 1599, 1599, 1599, 1599,
     1097, 1599, 1578, 1580, 1635, 1635, 1635, 1635, 1587, 1635,
     1096, 1580, 1580, 1580, 1580, 1094, 1093, 1092, 1090, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,

     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1580, 1582, 1582, 1582, 1582, 1599,
     1582, 1598, 1598, 1598, 1598, 1089, 1598, 1635, 1088, 1086,
     1074, 1073, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1654, 1072, 1071, 1070, 1069, 1068, 1066, 1064, 1654,
     1654, 1654, 1654, 1060, 1057, 1055, 1054, 1053, 1052, 1048,
     1045, 1041, 1602, 1602, 1602, 1602, 1039, 1602, 1582, 1584,
     1637, 1637, 1637, 1637, 1598, 1637, 1037, 1584, 1584, 1584,
     1584, 1035, 1034, 1020, 1019, 1584, 1584, 1584, 1584, 1584,
     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,

     1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1586, 1586, 1586, 1586, 1602, 1586, 1603, 1603, 1603,
     1603, 1018, 1603, 1637, 1602, 1017, 1016, 1015, 1586, 1586,
     1586, 1586, 1586, 1586, 1586, 1586, 1586, 1602, 1605, 1605,
     1605, 1605, 1013, 1605, 1606, 1606, 1606, 1606, 1012, 1606,
     1598, 1008, 1608, 1608, 1608, 1608, 1004, 1608, 1609, 1609,
     1609, 1609,  993, 1609, 1586,  992,  991,  990,  989,  988,
     1603,  986, 1639, 1639, 1639, 1639,  985, 1639,  977, 1603,
      966,  965, 1641, 1641, 1641, 1641,  963, 1641,  962,  961,
      959, 1605, 1603,  958,  957,  955,  943, 1606,  942,  941,

     1605,  940,  936,  934,  933, 1608, 1606, 1643, 1643, 1643,
     1643, 1609, 1643, 1605, 1608,  931,  930,  926,  925, 1606,
     1609, 1620, 1620, 1620, 1620, 1639, 1620, 1608,  920,  919,
      918,  904,  876, 1609, 1620, 1641, 1620,  875, 1620, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620,  873,  872,  871,
      848,  831,  830,  828,  827,  826,  824,  823,  822,  820,
     1643,  811,  810,  808,  807,  806,  804,  803, 1645, 1645,
     1645, 1645,  802, 1645, 1620, 1621, 1663, 1663, 1663, 1663,
      800, 1663,  786, 1621, 1621, 1621, 1621,  785,  784,  783,
      779, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621,

     1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621,
     1621, 1621, 1621, 1621, 1621, 1621, 1621, 1622, 1622, 1622,
     1622, 1645, 1622, 1678, 1678, 1678, 1678,  778, 1678, 1663,
     1622,  777, 1622,  776, 1622, 1622, 1622, 1622, 1622, 1622,
     1622, 1622, 1622,  773,  772,  771,  769,  766,  763,  760,
      750,  748,  746,  734,  733,  718,  714,  713,  686,  683,
      681,  680,  678,  670,  669,  668,  667,  666,  665,  663,
     1622, 1623,  661,  628,  623,  607, 1678,  606,  603, 1623,
     1623, 1623, 1623,  602,  601,  600,  599, 1623, 1623, 1623,
     1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623,

     1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623,
     1623, 1623, 1623, 1624, 1624, 1624, 1624,  598, 1624,  597,
      596,  595,  594,  593,  586,  582, 1624,  580, 1624,  577,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624,  571,
      567,  564,  563,  562,  556,  554,  553,  544,  541,  530,
      529,  528,  525,  524,  523,  514,  513,  477,  476,  472,
      470,  468,  463,  445,  439,  432, 1624, 1625,  431,  430,
      427,  426,  413,  411,  410, 1625, 1625, 1625, 1625,  409,
      408,  407,  406, 1625, 1625, 1625, 1625, 1625, 1625, 1625,
     1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625,

     1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1634,
     1634, 1634, 1634,  404, 1634,  403,  402,  401,  400,  398,
      397,  396,  393,  392,  391,  390, 1634, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634,  387, 1638, 1638, 1638, 1638,
      385, 1638,  382,  377,  376,  374,  367,  366,  365,  364,
      363,  362,  348, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1634, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636,
     1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1636, 1638,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,

     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1642, 1642, 1642, 1642,
      347, 1642,  345,  344,  340,  339,  337,  336,  334,  331,
      329,  315,  314, 1642, 1642, 1642, 1642, 1642, 1642, 1642,
     1642, 1642,  306,  305,  304,  303,  302,  300,  295,  293,
      288,  285,  282,  281,  278,  273,  271,  269,  258,  250,
      248,  245,  243,  240,  236,  234,  229,  225,  223, 1642,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1644, 1644, 1644, 1644, 1644, 1680, 1680, 1680, 1680,

     1680, 1680, 1680, 1680, 1680, 1680, 1680, 1681, 1681, 1681,
     1681, 1681, 1681, 1681, 1681, 1681, 1681, 1681, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1682, 1683,
     1683, 1683, 1683, 1683, 1683, 1683, 1683, 1683, 1683, 1683,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684,
     1684, 1685, 1685, 1685, 1685, 1685, 1685, 1685, 1685, 1685,
     1685, 1685, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1686, 1686, 1686, 1687, 1687, 1687, 1687, 1687, 1687, 1687,
     1687, 1687, 1687, 1687, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1688, 1688, 1688, 1689, 1689, 1689, 1689, 1689,

     1689, 1689, 1689, 1689, 1689, 1689, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1690, 1690, 1690, 1691, 1691, 1691,
     1691, 1692, 1692,  222, 1692, 1692, 1692, 1692, 1692, 1692,
     1692, 1692, 1693,  221,  220,  219, 1693, 1693, 1693, 1693,
     1693, 1693, 1693, 1694, 1694,  217,  215, 1694, 1694, 1694,
     1694, 1694, 1694, 1694, 1695, 1695,  209, 1695, 1695, 1695,
     1695, 1695, 1695, 1695, 1695, 1696,  205,  204,  202, 1696,
     1696, 1696, 1696, 1696, 1696, 1696, 1697,  199,  188,  187,
     1697, 1697, 1697, 1697, 1697, 1697, 1697, 1698,  186,  182,
      181, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1699, 1699,

      180, 1699, 1699, 1699, 1699, 1699, 1699, 1699, 1699, 1700,
     1700,  167, 1700, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1701, 1701,  159, 1701, 1701, 1701, 1701, 1701, 1701, 1701,
     1701, 1702, 1702,  152, 1702, 1702, 1702, 1702, 1702, 1702,
     1702, 1702, 1703, 1703, 1703, 1703, 1703, 1703, 1703, 1703,
     1703, 1703, 1703, 1704, 1704,  151, 1704, 1704, 1704, 1704,
     1704, 1704, 1704, 1704, 1705, 1705, 1705, 1705, 1706, 1706,
      149, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1707,
     1707,  146, 1707, 1707, 1707, 1707, 1707, 1707, 1707, 1707,
     1708, 1708,  130, 1708, 1708, 1708, 1708, 1708, 1708, 1708,

     1708, 1709, 1709,  129, 1709, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1710,  128, 1710, 1710, 1711, 1711, 1712,  127,
      121, 1712, 1712, 1713,  107,  104,  102, 1713, 1713, 1713,
     1713, 1713, 1713, 1713, 1714, 1714,   99,   96, 1714, 1714,
     1714, 1714, 1714, 1714, 1714, 1715, 1715,   94, 1715, 1715,
     1715, 1715, 1715, 1715, 1715, 1715, 1716,   93,   90,   89,
     1716, 1716, 1716, 1716, 1716, 1716, 1716, 1717,   86,   82,
       79, 1717, 1717, 1717, 1717, 1717, 1717, 1717, 1718,   76,
       73,   72, 1718, 1718, 1718, 1718, 1718, 1718, 1718, 1719,
     1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719,

     1720, 1720,   71, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1721, 1721,   70, 1721, 1721, 1721, 1721, 1721, 1721,
     1721, 1721, 1722, 1722,   66, 1722, 1722, 1722, 1722, 1722,
     1722, 1722, 1722, 1723, 1723,   63, 1723, 1723, 1723, 1723,
     1723, 1723, 1723, 1723, 1724, 1724,   59, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1725, 1725,   58, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1726, 1726, 1726, 1726,
     1726, 1726, 1726, 1726, 1726, 1726, 1726, 1727, 1727, 1727,
     1727, 1727, 1727, 1727, 1727, 1727, 1727, 1727, 1729, 1729,
       55, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1730,

     1730,   50, 1730, 1730, 1730, 1730, 1730, 1730, 1730, 1730,
     1731, 1731,   49, 1731, 1731, 1731, 1731, 1731, 1731, 1731,
     1731, 1732, 1732,   47, 1732, 1732, 1732, 1732, 1732, 1732,
     1732, 1732, 1733, 1733,   41, 1733, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1734, 1734,   37, 1734, 1734, 1734, 1734,
     1734, 1734, 1734, 1734, 1735, 1735, 1735, 1735, 1735,   36,
     1735, 1735, 1735, 1735, 1735, 1736, 1736,   35, 1736, 1736,
     1736, 1736, 1736, 1736, 1736, 1736, 1738, 1738, 1739, 1739,
     1739, 1739,   18, 1739, 1739, 1739, 1739, 1739, 1739, 1740,
     1740, 1740, 1740, 1740,   17, 1740, 1740, 1740, 1740, 1740,

     1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741, 1741,
     1741, 1742, 1742,    0, 1742, 1742, 1742, 1742, 1742, 1742,
     1742, 1742, 1743, 1743, 1743, 1743, 1743, 1743, 1743, 1743,
     1743, 1743, 1743, 1744, 1744,    0, 1744, 1744, 1744, 1744,
     1744, 1744, 1744, 1744, 1745, 1745,    0, 1745, 1745, 1745,
     1745, 1745, 1745, 1745, 1745, 1746, 1746,    0, 1746, 1746,
     1746, 1746, 1746, 1746, 1746, 1746, 1747, 1747,    0, 1747,
     1747, 1747, 1747, 1747, 1747, 1747, 1747, 1748, 1748,    0,
     1748, 1748, 1748, 1748, 1748, 1748, 1748, 1748, 1749, 1749,
        0, 1749, 1749, 1749, 1749, 1749, 1749, 1749, 1749, 1750,

     1750,    0, 1750, 1750, 1750, 1750, 1750, 1750, 1750, 1750,
     1751, 1751,    0, 1751, 1751, 1751, 1751, 1751, 1751, 1751,
     1751, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752, 1752,
     1752, 1752, 1753, 1753,    0, 1753, 1753, 1753, 1753, 1753,
     1753, 1753, 1753, 1754, 1754,    0, 1754, 1754, 1754, 1754,
     1754, 1754, 1754, 1754, 1755, 1755,    0, 1755, 1755, 1755,
     1755, 1755, 1755, 1755, 1755, 1756, 1756,    0, 1756, 1756,
     1756, 1756, 1756, 1756, 1756, 1756, 1757, 1757,    0, 1757,
     1757, 1757, 1757, 1757, 1757, 1757, 1757, 1758, 1758,    0,
     1758, 1758, 1758, 1758, 1758, 1758, 1758, 1758, 1759, 1759,

        0, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1759, 1760,
     1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760, 1760,
     1762, 1762, 1763, 1763, 1763, 1763, 1763, 1763, 1763, 1763,
     1763, 1763, 1763, 1764, 1764, 1764, 1764, 1764, 1764, 1764,
     1764, 1764, 1764, 1764, 1765, 1765,    0, 1765, 1765, 1765,
     1765, 1765, 1765, 1765, 1765, 1766, 1766,    0, 1766, 1766,
     1766, 1766, 1766, 1766, 1766, 1766, 1767, 1767,    0, 1767,
     1767, 1767, 1767, 1767, 1767, 1767, 1767, 1768, 1768,    0,
     1768, 1768, 1768, 1768, 1768, 1768, 1768, 1768, 1769, 1769,
        0, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1770,

     1770,    0, 1770, 1770, 1770, 1770, 1770, 1770, 1770, 1770,
     1771, 1771,    0, 1771, 1771, 1771, 1771, 1771, 1771, 1771,
     1771, 1772, 1772,    0, 1772, 1772, 1772, 1772, 1772, 1772,
     1772, 1772, 1773, 1773,    0, 1773, 1773, 1773, 1773, 1773,
     1773, 1773, 1773, 1774, 1774,    0, 1774, 1774, 1774, 1774,
     1774, 1774, 1774, 1774, 1775, 1775,    0, 1775, 1775, 1775,
     1775, 1775, 1775, 1775, 1775, 1776, 1776,    0, 1776, 1776,
     1776, 1776, 1776, 1776, 1776, 1776, 1777, 1777,    0, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1778, 1778,    0,
     1778, 1778, 1778, 1778, 1778, 1778, 1778, 1778, 1779, 1779,

        0, 1779, 1779, 1779, 1779, 1779, 1779, 1779, 1779, 1780,
     1780,    0, 1780, 1780, 1780, 1780, 1780, 1780, 1780, 1780,
     1781, 1781,    0, 1781, 1781, 1781, 1781, 1781, 1781, 1781,
     1781, 1782, 1782,    0, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1783, 1783,    0, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1784, 1784, 1784, 1784, 1784, 1784, 1784,
     1784, 1784, 1784, 1784, 1785, 1785, 1785, 1785, 1785, 1785,
     1785, 1785, 1785, 1785, 1785, 1786, 1786, 1786, 1786, 1786,
     1786, 1786, 1786, 1786, 1786, 1786, 1787, 1787,    0, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1788, 1788,    0,

     1788, 1788, 1788, 1788, 1788, 1788, 1788, 1788, 1789, 1789,
        0, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1789, 1790,
     1790,    0, 1790, 1790, 1790, 1790, 1790, 1790, 1790, 1790,
     1791, 1791,    0, 1791, 1791, 1791, 1791, 1791, 1791, 1791,
     1791, 1792, 1792,    0, 1792, 1792, 1792, 1792, 1792, 1792,
     1792, 1792, 1793, 1793,    0, 1793, 1793, 1793, 1793, 1793,
     1793, 1793, 1793, 1794, 1794,    0, 1794, 1794, 1794, 1794,
     1794, 1794, 1794, 1794, 1795,    0, 1795, 1795, 1795, 1795,
     1795, 1795, 1795, 1795, 1795, 1796, 1796,    0, 1796, 1796,
     1796, 1796, 1796, 1796, 1796, 1796, 1797, 1797, 1797, 1797,

     1797, 1797, 1797, 1797, 1797, 1797, 1797, 1798, 1798,    0,
     1798, 1798, 1798, 1798, 1798, 1798, 1798, 1798, 1799, 1799,
        0, 1799, 1799, 1799, 1799, 1799, 1799, 1799, 1799, 1800,
     1800,    0, 1800, 1800, 1800, 1800, 1800, 1800, 1800, 1800,
     1801, 1801,    0, 1801, 1801, 1801, 1801, 1801, 1801, 1801,
     1801, 1802, 1802,    0, 1802, 1802, 1802, 1802, 1802, 1802,
     1802, 1802, 1803, 1803,    0, 1803, 1803, 1803, 1803, 1803,
     1803, 1803, 1803, 1804, 1804,    0, 1804, 1804, 1804, 1804,
     1804, 1804, 1804, 1804, 1805, 1805,    0, 1805, 1805, 1805,
     1805, 1805, 1805, 1805, 1805, 1806, 1806,    0, 1806, 1806,

     1806, 1806, 1806, 1806, 1806, 1806, 1807, 1807,    0, 1807,
     1807, 1807, 1807, 1807, 1807, 1807, 1807, 1808, 1808,    0,
     1808, 1808, 1808, 1808, 1808, 1808, 1808, 1808, 1809, 1809,
        0, 1809, 1809, 1809, 1809, 1809, 1809, 1809, 1809, 1810,
     1810,    0, 1810, 1810, 1810, 1810, 1810, 1810, 1810, 1810,
     1811, 1811,    0, 1811, 1811, 1811, 1811, 1811, 1811, 1811,
     1811, 1812, 1812,    0, 1812, 1812, 1812, 1812, 1812, 1812,
     1812, 1812, 1813, 1813,    0, 1813, 1813, 1813, 1813, 1813,
     1813, 1813, 1813, 1814, 1814,    0, 1814, 1814, 1814, 1814,
     1814, 1814, 1814, 1814, 1815, 1815,    0, 1815, 1815, 1815,

     1815, 1815, 1815, 1815, 1815, 1816, 1816,    0, 1816, 1816,
     1816, 1816, 1816, 1816, 1816, 1816, 1817, 1817,    0, 1817,
     1817, 1817, 1817, 1817, 1817, 1817, 1817, 1818, 1818,    0,
     1818, 1818, 1818, 1818, 1818, 1818, 1818, 1818, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1820,
     1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820, 1820,
     1821, 1821, 1821, 1821, 1821, 1821, 1821, 1821, 1821, 1821,
     1821, 1822, 1822,    0, 1822, 1822, 1822, 1822, 1822, 1822,
     1822, 1822, 1823, 1823,    0, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1824, 1824,    0, 1824, 1824, 1824, 1824,

     1824, 1824, 1824, 1824, 1825, 1825,    0, 1825, 1825, 1825,
     1825, 1825, 1825, 1825, 1825, 1826, 1826,    0, 1826, 1826,
     1826, 1826, 1826, 1826, 1826, 1826, 1827, 1827,    0, 1827,
     1827, 1827, 1827, 1827, 1827, 1827, 1827, 1828, 1828,    0,
     1828, 1828, 1828, 1828, 1828, 1828, 1828, 1828, 1829,    0,
     1829, 1829, 1829, 1829, 1829, 1829, 1829, 1829, 1829, 1830,
     1830,    0, 1830, 1830, 1830, 1830, 1830, 1830, 1830, 1830,
     1831, 1831,    0, 1831, 1831, 1831, 1831, 1831, 1831, 1831,
     1831, 1832, 1832,    0, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1833,    0, 1833, 1833, 1834, 1834,    0, 1834,

     1834, 1834, 1834, 1834, 1834, 1834, 1834, 1835, 1835,    0,
     1835, 1835, 1835, 1835, 1835, 1835, 1835, 1835, 1836, 1836,
        0, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1837,
     1837,    0, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1838, 1838,    0, 1838, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1839, 1839,    0, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1840, 1840,    0, 1840, 1840, 1840, 1840, 1840,
     1840, 1840, 1840, 1841, 1841,    0, 1841, 1841, 1841, 1841,
     1841, 1841, 1841, 1841, 1842, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1843, 1843,    0, 1843, 1843,

     1843, 1843, 1843, 1843, 1843, 1843, 1844, 1844,    0, 1844,
     1844, 1844, 1844, 1844, 1844, 1844, 1844, 1845, 1845,    0,
     1845, 1845, 1845, 1845, 1845, 1845, 1845, 1845, 1847, 1847,
        0, 1847, 1847, 1847, 1847, 1847, 1847, 1847, 1847, 1848,
     1848,    0, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848,
     1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849,
     1849, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     1850, 1850, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1852, 1852,    0, 1852, 1852, 1852, 1852,
     1852, 1852, 1852, 1852, 1853,    0, 1853,    0, 1853, 1853,

     1854,    0, 1854,    0, 1854, 1854, 1855, 1855,    0, 1855,
     1855, 1855, 1855, 1855, 1855, 1855, 1855, 1857,    0, 1857,
     1857, 1859, 1859, 1859, 1859, 1859, 1859, 1859, 1859, 1859,
     1859, 1859, 1860, 1860, 1860, 1860, 1860, 1860, 1860, 1860,
     1860, 1860, 1860, 1861, 1861, 1861, 1861, 1861, 1861, 1861,
     1861, 1861, 1861, 1861, 1862,    0, 1862, 1862, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679, 1679,

     1679
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk)
 *
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "error.h"
#include "xalloc.h"

#include "gettext.h"
#define _(String) gettext (String)

#include "encodings.h"
#include "pipeline.h"
#include "sandbox.h"
#include "security.h"
#include "util.h"

#include "decompress.h"
#include "lexgrog.h"
#include "manconv.h"
#include "manconv_client.h"

#define YY_READ_BUF_SIZE	YY_BUF_SIZE
#define MAX_NAME		8192

/* defines the ordered list of filters detected by lexgrog */
enum {
	TBL_FILTER = 0,	/* tbl */
	EQN_FILTER,	/* eqn */
	PIC_FILTER,	/* pic */
	GRAP_FILTER,	/* grap */
	REF_FILTER,	/* refer */
	VGRIND_FILTER,	/* vgrind */
	MAX_FILTERS	/* delimiter */
};

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

extern man_sandbox *sandbox;

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static __inline__ void add_str_to_whatis (const char *string, size_t length);
static __inline__ void add_char_to_whatis (unsigned char c);
static __inline__ void add_separator_to_whatis (void);
static __inline__ void add_wordn_to_whatis (const char *string, size_t length);
static __inline__ void add_word_to_whatis (const char *string);
static __inline__ void add_glyph_to_whatis (const char *string, size_t length);
static __inline__ void add_perldoc_to_whatis (const char *string, size_t length);
static __inline__ void mdoc_text (const char *string);
static __inline__ void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static bool fill_mode;
static bool waiting_for_quote;
static int have_separator;

static decompress *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = decompress_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 3136 "lexgrog.c"

#line 311 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* ИМЕ also works for mk */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 3147 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 381 "lexgrog.l"


 /* begin NAME section processing */
#line 3383 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1680 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1679 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
#line 386 "lexgrog.l"
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 386 "lexgrog.l"
{			/* default */
							BEGIN (MAN_PRENAME);
					}
	YY_BREAK

case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
#line 390 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 4:
#line 395 "lexgrog.l"
case 5:
#line 396 "lexgrog.l"
case 6:
#line 397 "lexgrog.l"
case 7:
/* rule 7 can match eol */
YY_RULE_SETUP
#line 397 "lexgrog.l"

	YY_BREAK


case 8:
#line 402 "lexgrog.l"
case 9:
#line 403 "lexgrog.l"
case 10:
/* rule 10 can match eol */
#line 404 "lexgrog.l"
case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 404 "lexgrog.l"

	YY_BREAK


case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 408 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 409 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 410 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
#line 411 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 16:
/* rule 16 can match eol */
#line 413 "lexgrog.l"
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 413 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 414 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 416 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 420 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 20:
/* rule 20 can match eol */
YY_RULE_SETUP
#line 423 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 21:
/* rule 21 can match eol */
#line 429 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 429 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 22:
/* rule 22 can match eol */
#line 438 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 439 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 440 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 441 "lexgrog.l"
case 26:
/* rule 26 can match eol */
#line 442 "lexgrog.l"
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 442 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 450 "lexgrog.l"

	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 452 "lexgrog.l"
yyless (1);
	YY_BREAK
case 30:
/* rule 30 can match eol */
YY_RULE_SETUP
#line 454 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 31:
/* rule 31 can match eol */
#line 461 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 462 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 463 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 464 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 465 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 466 "lexgrog.l"
case 37:
/* rule 37 can match eol */
#line 467 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 468 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 468 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 39:
/* rule 39 can match eol */
#line 476 "lexgrog.l"
case 40:
/* rule 40 can match eol */
#line 477 "lexgrog.l"
case 41:
/* rule 41 can match eol */
YY_RULE_SETUP
#line 477 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 42:
/* rule 42 can match eol */
YY_RULE_SETUP
#line 487 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = true;
	}
	YY_BREAK
case 43:
/* rule 43 can match eol */
#line 493 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 494 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 495 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 496 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 497 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 498 "lexgrog.l"
case 49:
/* rule 49 can match eol */
#line 499 "lexgrog.l"
case 50:
/* rule 50 can match eol */
#line 500 "lexgrog.l"
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 500 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 52:
/* rule 52 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 507 "lexgrog.l"
newline_found ();
	YY_BREAK
case 53:
/* rule 53 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 508 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
fill_mode = false;
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 514 "lexgrog.l"
fill_mode = true;
	YY_BREAK

case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 517 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 57:
/* rule 57 can match eol */
#line 522 "lexgrog.l"
case 58:
/* rule 58 can match eol */
#line 523 "lexgrog.l"
case 59:
/* rule 59 can match eol */
#line 524 "lexgrog.l"
case 60:
/* rule 60 can match eol */
#line 525 "lexgrog.l"
case 61:
/* rule 61 can match eol */
#line 526 "lexgrog.l"
case 62:
/* rule 62 can match eol */
#line 527 "lexgrog.l"
case 63:
/* rule 63 can match eol */
#line 528 "lexgrog.l"
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 528 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 533 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 537 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 538 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 539 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 540 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 541 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 542 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 543 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 544 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 545 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 547 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 548 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 550 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 553 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 555 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 556 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 558 "lexgrog.l"
/* comment */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 560 "lexgrog.l"
/* font changes */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 561 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 563 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 564 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 566 "lexgrog.l"
/* size changes */
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 567 "lexgrog.l"
/* width of string */
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 569 "lexgrog.l"
/* catch all */
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 571 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 578 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 579 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 580 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
#line 581 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 94:
/* rule 94 can match eol */
YY_RULE_SETUP
#line 582 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 95:
/* rule 95 can match eol */
YY_RULE_SETUP
#line 583 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 96:
/* rule 96 can match eol */
YY_RULE_SETUP
#line 584 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 97:
/* rule 97 can match eol */
YY_RULE_SETUP
#line 586 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 98:
YY_RULE_SETUP
#line 593 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 594 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 595 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 596 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 597 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 598 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 599 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 600 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 601 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 107:
YY_RULE_SETUP
#line 602 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 108:
YY_RULE_SETUP
#line 603 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 109:
YY_RULE_SETUP
#line 604 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 605 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 111:
/* rule 111 can match eol */
YY_RULE_SETUP
#line 606 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 112:
YY_RULE_SETUP
#line 613 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 618 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 114:
YY_RULE_SETUP
#line 625 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 626 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 627 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 628 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 633 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 119:
YY_RULE_SETUP
#line 640 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 120:
YY_RULE_SETUP
#line 644 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 648 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 122:
YY_RULE_SETUP
#line 652 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 656 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 124:
YY_RULE_SETUP
#line 662 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 125:
YY_RULE_SETUP
#line 669 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 674 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 127:
YY_RULE_SETUP
#line 681 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 128:
/* rule 128 can match eol */
YY_RULE_SETUP
#line 686 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 129:
YY_RULE_SETUP
#line 693 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 130:
/* rule 130 can match eol */
YY_RULE_SETUP
#line 698 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 131:
/* rule 131 can match eol */
YY_RULE_SETUP
#line 705 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 132:
/* rule 132 can match eol */
#line 712 "lexgrog.l"
case 133:
/* rule 133 can match eol */
#line 713 "lexgrog.l"
case 134:
/* rule 134 can match eol */
#line 714 "lexgrog.l"
case 135:
/* rule 135 can match eol */
#line 715 "lexgrog.l"
case 136:
/* rule 136 can match eol */
#line 716 "lexgrog.l"
case 137:
/* rule 137 can match eol */
#line 717 "lexgrog.l"
case 138:
/* rule 138 can match eol */
#line 718 "lexgrog.l"
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 718 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 140:
/* rule 140 can match eol */
YY_RULE_SETUP
#line 725 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 141:
YY_RULE_SETUP
#line 731 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 142:
/* rule 142 can match eol */
#line 735 "lexgrog.l"
case 143:
/* rule 143 can match eol */
YY_RULE_SETUP
#line 735 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 144:
/* rule 144 can match eol */
YY_RULE_SETUP
#line 737 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 742 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 745 "lexgrog.l"
return 1;
	YY_BREAK
case 146:
YY_RULE_SETUP
#line 747 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4345 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1680 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1680 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1679);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 747 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
}

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = false;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = false;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret = 0;
	decompress *d;
	char *page_encoding = NULL;
	bool run_col = p_lg->type == CATPAGE && *PROG_COL != '\0';

	if (strcmp (file, "-") == 0) {
		d = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		int decompress_flags;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		decompress_flags = 0;
		/* If we're looking at a cat page, then we need to run col
		 * over it, which doesn't work conveniently with an
		 * in-process decompressor.
		 */
		if (!run_col)
			decompress_flags |= DECOMPRESS_ALLOW_INPROCESS;
		d = decompress_open (file, decompress_flags);
		if (!d) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding) {
		if (decompress_is_pipeline (d))
			add_manconv (decompress_get_pipeline (d),
				     page_encoding, "UTF-8");
		else if (manconv_inprocess (d, page_encoding, "UTF-8") != 0)
			/* manconv should already have written to stderr, so
			 * just return zero (i.e. no result).
			 */
			goto out;
	}
	if (run_col) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args
			(PROG_COL, "-b", "-p", "-x", (void *) 0);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (decompress_get_pipeline (d), col_cmd);
	}
	decompress_start (d);

	ret = find_name_decompressed (d, filename, p_lg);

out:
	free (page_encoding);
	decompress_free (d);
	return ret;
}

int find_name_decompressed (decompress *d, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = d;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = true;
	waiting_for_quote = false;

	if (p_lg->type == CATPAGE)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	decompress_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

